/* Instruction opcode table for calmrisc16.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of the GNU Binutils and/or GDB, the GNU debugger.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#include "sysdep.h"
#include "ansidecl.h"
#include "bfd.h"
#include "symcat.h"
#include "calmrisc16-desc.h"
#include "calmrisc16-opc.h"
#include "libiberty.h"

/* The hash functions are recorded here to help keep assembler code out of
   the disassembler and vice versa.  */

static int asm_hash_insn_p PARAMS ((const CGEN_INSN *));
static unsigned int asm_hash_insn PARAMS ((const char *));
static int dis_hash_insn_p PARAMS ((const CGEN_INSN *));
static unsigned int dis_hash_insn PARAMS ((const char *, CGEN_INSN_INT));

/* Instruction formats.  */

#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define F(f) & calmrisc16_cgen_ifld_table[CALMRISC16_##f]
#else
#define F(f) & calmrisc16_cgen_ifld_table[CALMRISC16_/**/f]
#endif
static const CGEN_IFMT ifmt_empty = {
  0, 0, 0x0, { { 0 } }
};

static const CGEN_IFMT ifmt_clrsrfe = {
  16, 16, 0xffff, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_BS3) }, { 0 } }
};

static const CGEN_IFMT ifmt_addgrgr = {
  16, 16, 0xf0f0, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP3) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_muluu = {
  16, 16, 0xf8f8, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_DN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_addgri7 = {
  16, 16, 0xf080, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP8_1) }, { F (F_IMM7) }, { 0 } }
};

static const CGEN_IFMT ifmt_addgri16 = {
  16, 32, 0xfff0, { { F (F_OP1) }, { F (F_IMM16) }, { F (F_OP2) }, { F (F_OP3) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_addargr = {
  16, 16, 0xf8f0, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_AN) }, { F (F_OP3) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_addari5 = {
  16, 16, 0xf8e0, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_AN) }, { F (F_OP8_3) }, { F (F_IMM5) }, { 0 } }
};

static const CGEN_IFMT ifmt_addari16 = {
  16, 32, 0xfff8, { { F (F_OP1) }, { F (F_IMM16) }, { F (F_OP2) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_com = {
  16, 16, 0xfff0, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP3) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_andgri8 = {
  16, 16, 0xff00, { { F (F_OP1) }, { F (F_OP2) }, { F (F_IMM8) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldwaRj = {
  16, 16, 0xf080, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldaaRj = {
  16, 16, 0xf880, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_AN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldwaedisp5 = {
  16, 16, 0xf080, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_EDISP5) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldaaedisp5 = {
  16, 16, 0xf880, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_AN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_EDISP5) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldwspedisp9 = {
  16, 16, 0xf000, { { F (F_OP1) }, { F (F_RN) }, { F (F_EDISP9) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldw_gr_a_disp16 = {
  16, 32, 0xf0f8, { { F (F_OP1) }, { F (F_DISP16) }, { F (F_RN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldw_ar_a_disp16 = {
  16, 32, 0xf8f8, { { F (F_OP1) }, { F (F_DISP16) }, { F (F_OP4_1) }, { F (F_AN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldbaRj = {
  16, 16, 0xf880, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldbadisp4 = {
  16, 16, 0xf880, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_DISP4) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldba8disp8 = {
  16, 16, 0xff00, { { F (F_OP1) }, { F (F_OP2) }, { F (F_DISP8) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldbadisp16 = {
  16, 32, 0xf8f8, { { F (F_OP1) }, { F (F_DISP16) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldEnDi = {
  16, 16, 0xf8f8, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_EN) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldDnEi = {
  16, 16, 0xf8f8, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_EN) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldAnAi = {
  16, 16, 0xf8f8, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_AN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldAnpc = {
  16, 16, 0xfff8, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldr0srx = {
  16, 16, 0xfff0, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP3) }, { F (F_RS) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldsrr0 = {
  16, 16, 0xffff, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP3) }, { F (F_OP4) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldi8 = {
  16, 16, 0xf000, { { F (F_OP1) }, { F (F_RN) }, { F (F_IMM8) }, { 0 } }
};

static const CGEN_IFMT ifmt_lda22 = {
  16, 32, 0xf8c0, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_AN) }, { F (F_OP8_2) }, { F (F_IMM22) }, { 0 } }
};

static const CGEN_IFMT ifmt_popgr = {
  16, 16, 0xf0f8, { { F (F_OP1) }, { F (F_RLIST) }, { F (F_OP3) }, { F (F_OP12_1) }, { 0 } }
};

static const CGEN_IFMT ifmt_popar = {
  16, 16, 0xf8f8, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_ALIST) }, { F (F_OP3) }, { F (F_OP12_1) }, { 0 } }
};

static const CGEN_IFMT ifmt_ldc = {
  16, 16, 0xf0f8, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_stwaRj = {
  16, 16, 0xf080, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_stwaedisp5 = {
  16, 16, 0xf080, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_EDISP5) }, { 0 } }
};

static const CGEN_IFMT ifmt_stwspedisp9 = {
  16, 16, 0xf000, { { F (F_OP1) }, { F (F_RN) }, { F (F_EDISP9) }, { 0 } }
};

static const CGEN_IFMT ifmt_stwadisp16 = {
  16, 32, 0xf0f8, { { F (F_OP1) }, { F (F_DISP16) }, { F (F_RN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_stbaRm = {
  16, 16, 0xf880, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_RM) }, { 0 } }
};

static const CGEN_IFMT ifmt_stbadisp4 = {
  16, 16, 0xf880, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP8_1) }, { F (F_AN2) }, { F (F_DISP4) }, { 0 } }
};

static const CGEN_IFMT ifmt_stbadisp16 = {
  16, 32, 0xf8f8, { { F (F_OP1) }, { F (F_DISP16) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_bitr = {
  16, 16, 0xfff8, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_BS3) }, { 0 } }
};

static const CGEN_IFMT ifmt_cmpgegr = {
  16, 16, 0xf0f0, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP8_1) }, { F (F_CMODE1) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_cmpgegrimm6 = {
  16, 16, 0xf8c0, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_OP8_2) }, { F (F_IMM6) }, { 0 } }
};

static const CGEN_IFMT ifmt_cmpeqgrimm8 = {
  16, 16, 0xf800, { { F (F_OP1) }, { F (F_OP4_1) }, { F (F_DN) }, { F (F_IMM8) }, { 0 } }
};

static const CGEN_IFMT ifmt_cmpgei16 = {
  16, 32, 0xfff0, { { F (F_OP1) }, { F (F_IMM16) }, { F (F_OP4_1) }, { F (F_CMODE2) }, { F (F_OP3) }, { F (F_RN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_braext = {
  16, 16, 0xfe00, { { F (F_OP1) }, { F (F_OP4_3) }, { F (F_EC2) }, { F (F_EOFFSET8) }, { 0 } }
};

static const CGEN_IFMT ifmt_bra = {
  16, 16, 0xfc00, { { F (F_OP0_3) }, { F (F_BMODE) }, { F (F_D) }, { F (F_EOFFSET11) }, { 0 } }
};

static const CGEN_IFMT ifmt_bnzd = {
  16, 16, 0xfe80, { { F (F_OP1) }, { F (F_OP4_3) }, { F (F_H) }, { F (F_OP8_1) }, { F (F_EOFFSET8) }, { 0 } }
};

static const CGEN_IFMT ifmt_jpfAi = {
  16, 16, 0xfff8, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP3) }, { F (F_OP12_1) }, { F (F_AN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_jpfimm22 = {
  16, 32, 0xffc0, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP8_1) }, { F (F_OP9_1) }, { F (F_IMM22) }, { 0 } }
};

static const CGEN_IFMT ifmt_jmpimm22 = {
  16, 32, 0xffc0, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP8_2) }, { F (F_IMM22) }, { 0 } }
};

static const CGEN_IFMT ifmt_bsrd = {
  16, 16, 0xf000, { { F (F_OP1) }, { F (F_EOFFSET13) }, { 0 } }
};

static const CGEN_IFMT ifmt_swi = {
  16, 16, 0xffc0, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP8_2) }, { F (F_IMM6) }, { 0 } }
};

static const CGEN_IFMT ifmt_cldr = {
  16, 16, 0xfe08, { { F (F_OP1) }, { F (F_OP4_3) }, { F (F_IMM5C) }, { F (F_OP12_1) }, { F (F_DN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_cldw = {
  16, 16, 0xfe08, { { F (F_OP1) }, { F (F_OP4_3) }, { F (F_IMM5C) }, { F (F_OP12_1) }, { F (F_DN1) }, { 0 } }
};

static const CGEN_IFMT ifmt_cop = {
  16, 16, 0xe000, { { F (F_OP0_3) }, { F (F_IMM13) }, { 0 } }
};

static const CGEN_IFMT ifmt_sys = {
  16, 16, 0xffe0, { { F (F_OP1) }, { F (F_OP2) }, { F (F_OP8_3) }, { F (F_IMM5) }, { 0 } }
};

#undef F

#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define A(a) (1 << CGEN_INSN_##a)
#else
#define A(a) (1 << CGEN_INSN_/**/a)
#endif
#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define OPERAND(op) CALMRISC16_OPERAND_##op
#else
#define OPERAND(op) CALMRISC16_OPERAND_/**/op
#endif
#define MNEM CGEN_SYNTAX_MNEMONIC /* syntax value for mnemonic */
#define OP(field) CGEN_SYNTAX_MAKE_FIELD (OPERAND (field))

/* The instruction table.  */

static const CGEN_OPCODE calmrisc16_cgen_insn_opcode_table[MAX_INSNS] =
{
  /* Special null first entry.
     A `num' value of zero is thus invalid.
     Also, the special `invalid' insn resides here.  */
  { { 0, 0, 0, 0 }, {{0}}, 0, {0}},
/* clrsr fe */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'f', 'e', 0 } },
    & ifmt_clrsrfe, { 0x9e80 }
  },
/* setsr fe */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'f', 'e', 0 } },
    & ifmt_clrsrfe, { 0x9e88 }
  },
/* tstsr fe */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'f', 'e', 0 } },
    & ifmt_clrsrfe, { 0x9e90 }
  },
/* clrsr ie */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'i', 'e', 0 } },
    & ifmt_clrsrfe, { 0x9e81 }
  },
/* setsr ie */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'i', 'e', 0 } },
    & ifmt_clrsrfe, { 0x9e89 }
  },
/* tstsr ie */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'i', 'e', 0 } },
    & ifmt_clrsrfe, { 0x9e91 }
  },
/* clrsr te */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 't', 'e', 0 } },
    & ifmt_clrsrfe, { 0x9e82 }
  },
/* setsr te */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 't', 'e', 0 } },
    & ifmt_clrsrfe, { 0x9e8a }
  },
/* tstsr te */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 't', 'e', 0 } },
    & ifmt_clrsrfe, { 0x9e92 }
  },
/* clrsr v */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'v', 0 } },
    & ifmt_clrsrfe, { 0x9e83 }
  },
/* setsr v */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'v', 0 } },
    & ifmt_clrsrfe, { 0x9e8b }
  },
/* tstsr v */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'v', 0 } },
    & ifmt_clrsrfe, { 0x9e93 }
  },
/* clrsr z0 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'z', '0', 0 } },
    & ifmt_clrsrfe, { 0x9e84 }
  },
/* setsr z0 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'z', '0', 0 } },
    & ifmt_clrsrfe, { 0x9e8c }
  },
/* tstsr z0 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'z', '0', 0 } },
    & ifmt_clrsrfe, { 0x9e94 }
  },
/* clrsr z1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'z', '1', 0 } },
    & ifmt_clrsrfe, { 0x9e85 }
  },
/* setsr z1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'z', '1', 0 } },
    & ifmt_clrsrfe, { 0x9e8d }
  },
/* tstsr z1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'z', '1', 0 } },
    & ifmt_clrsrfe, { 0x9e95 }
  },
/* clrsr pm */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'p', 'm', 0 } },
    & ifmt_clrsrfe, { 0x9e86 }
  },
/* setsr pm */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'p', 'm', 0 } },
    & ifmt_clrsrfe, { 0x9e8e }
  },
/* tstsr pm */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'p', 'm', 0 } },
    & ifmt_clrsrfe, { 0x9e96 }
  },
/* add $Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (RI), 0 } },
    & ifmt_addgrgr, { 0x8000 }
  },
/* sub $Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (RI), 0 } },
    & ifmt_addgrgr, { 0x8010 }
  },
/* adc $Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (RI), 0 } },
    & ifmt_addgrgr, { 0x8020 }
  },
/* sbc $Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (RI), 0 } },
    & ifmt_addgrgr, { 0x8030 }
  },
/* mul uu,$Dn,$Di1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'u', 'u', ',', OP (DN), ',', OP (DI1), 0 } },
    & ifmt_muluu, { 0xa0d0 }
  },
/* mul us,$Dn,$Di1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'u', 's', ',', OP (DN), ',', OP (DI1), 0 } },
    & ifmt_muluu, { 0xa0d8 }
  },
/* mul su,$Dn,$Di1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 's', 'u', ',', OP (DN), ',', OP (DI1), 0 } },
    & ifmt_muluu, { 0xa8d0 }
  },
/* mul ss,$Dn,$Di1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 's', 's', ',', OP (DN), ',', OP (DI1), 0 } },
    & ifmt_muluu, { 0xa8d8 }
  },
/* add $Rn,$imm7 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (IMM7), 0 } },
    & ifmt_addgri7, { 0x0 }
  },
/* sub $Rn,$imm7 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (IMM7), 0 } },
    & ifmt_addgri7, { 0x80 }
  },
/* add $Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_addgri16, { 0x80f0 }
  },
/* adc $Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_addgri16, { 0x82f0 }
  },
/* sbc $Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_addgri16, { 0x83f0 }
  },
/* add $An,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN), ',', OP (RI), 0 } },
    & ifmt_addargr, { 0xa0c0 }
  },
/* sub $An,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN), ',', OP (RI), 0 } },
    & ifmt_addargr, { 0xa8c0 }
  },
/* add $An,$imm5 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN), ',', OP (IMM5), 0 } },
    & ifmt_addari5, { 0xa840 }
  },
/* sub $An,$imm5 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN), ',', OP (IMM5), 0 } },
    & ifmt_addari5, { 0xa860 }
  },
/* add $An1,$imm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN1), ',', OP (IMM16), 0 } },
    & ifmt_addari16, { 0x81f0 }
  },
/* sub $An1,$imm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN1), ',', OP (IMM16), 0 } },
    & ifmt_addari16, { 0x81f8 }
  },
/* com $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x8ce0 }
  },
/* com2 $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x8de0 }
  },
/* comc $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x8ee0 }
  },
/* decc $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x8be0 }
  },
/* incc $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x8ae0 }
  },
/* dt $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x89e0 }
  },
/* ext $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x8fe0 }
  },
/* rr $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x80e0 }
  },
/* sr $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x84e0 }
  },
/* sra $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x85e0 }
  },
/* srb $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x83e0 }
  },
/* slb $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x88e0 }
  },
/* rrc $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x82e0 }
  },
/* rl $Rn1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), 0 } },
    & ifmt_com, { 0x81e0 }
  },
/* and $Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (RI), 0 } },
    & ifmt_addgrgr, { 0x8040 }
  },
/* or $Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (RI), 0 } },
    & ifmt_addgrgr, { 0x8050 }
  },
/* xor $Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (RI), 0 } },
    & ifmt_addgrgr, { 0x8060 }
  },
/* tst $Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (RI), 0 } },
    & ifmt_addgrgr, { 0x8070 }
  },
/* and r0,$imm8 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'r', '0', ',', OP (IMM8), 0 } },
    & ifmt_andgri8, { 0x9800 }
  },
/* or r0,$imm8 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'r', '0', ',', OP (IMM8), 0 } },
    & ifmt_andgri8, { 0x9900 }
  },
/* xor r0,$imm8 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'r', '0', ',', OP (IMM8), 0 } },
    & ifmt_andgri8, { 0x9a00 }
  },
/* tst r0,$imm8 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'r', '0', ',', OP (IMM8), 0 } },
    & ifmt_andgri8, { 0x9b00 }
  },
/* and $Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_addgri16, { 0x84f0 }
  },
/* or $Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_addgri16, { 0x85f0 }
  },
/* xor $Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_addgri16, { 0x86f0 }
  },
/* tst $Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_addgri16, { 0x87f0 }
  },
/* ldw $Rn,@[$Ai1+$Rj] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', '@', '[', OP (AI1), '+', OP (RJ), ']', 0 } },
    & ifmt_ldwaRj, { 0x4080 }
  },
/* ldw $An,@[$Ai1+$Rj] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN), ',', '@', '[', OP (AI1), '+', OP (RJ), ']', 0 } },
    & ifmt_ldaaRj, { 0x6880 }
  },
/* ldw $Rn,@[$Ai1+$edisp5] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', '@', '[', OP (AI1), '+', OP (EDISP5), ']', 0 } },
    & ifmt_ldwaedisp5, { 0x4000 }
  },
/* ldw $An,@[$Ai1+$edisp5] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN), ',', '@', '[', OP (AI1), '+', OP (EDISP5), ']', 0 } },
    & ifmt_ldaaedisp5, { 0x6800 }
  },
/* ldw $Rn,@[$sp+$edisp9] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', '@', '[', OP (SP), '+', OP (EDISP9), ']', 0 } },
    & ifmt_ldwspedisp9, { 0x2000 }
  },
/* ldw $Rn,@[$Ai+$disp16] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', '@', '[', OP (AI), '+', OP (DISP16), ']', 0 } },
    & ifmt_ldw_gr_a_disp16, { 0xa020 }
  },
/* ldw $An,@[$Ai+$disp16] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN), ',', '@', '[', OP (AI), '+', OP (DISP16), ']', 0 } },
    & ifmt_ldw_ar_a_disp16, { 0xa830 }
  },
/* ldb $Dn,@[$Ai1+$Rj] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (DN), ',', '@', '[', OP (AI1), '+', OP (RJ), ']', 0 } },
    & ifmt_ldbaRj, { 0x6080 }
  },
/* ldb $Dn,@[$Ai1+$disp4] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (DN), ',', '@', '[', OP (AI1), '+', OP (DISP4), ']', 0 } },
    & ifmt_ldbadisp4, { 0x6000 }
  },
/* ldb r0,@[a8+$disp8] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'r', '0', ',', '@', '[', 'a', '8', '+', OP (DISP8), ']', 0 } },
    & ifmt_ldba8disp8, { 0x9c00 }
  },
/* ldb $Dn,@[$Ai+$disp16] */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (DN), ',', '@', '[', OP (AI), '+', OP (DISP16), ']', 0 } },
    & ifmt_ldbadisp16, { 0xa030 }
  },
/* ld $En,$Di */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (EN), ',', OP (DI), 0 } },
    & ifmt_ldEnDi, { 0xa018 }
  },
/* ld $Dn,$Ei */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (DN), ',', OP (EI), 0 } },
    & ifmt_ldDnEi, { 0xa010 }
  },
/* ld $Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (RI), 0 } },
    & ifmt_addgrgr, { 0x80d0 }
  },
/* ld $An,$Ai */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN), ',', OP (AI), 0 } },
    & ifmt_ldAnAi, { 0xa818 }
  },
/* ld $An1,pc */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN1), ',', 'p', 'c', 0 } },
    & ifmt_ldAnpc, { 0x9ef0 }
  },
/* ld r0,$Rs */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'r', '0', ',', OP (RS), 0 } },
    & ifmt_ldr0srx, { 0x9ea0 }
  },
/* ld $Rs,r0 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RS), ',', 'r', '0', 0 } },
    & ifmt_ldr0srx, { 0x9eb0 }
  },
/* ld sr,r0 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 's', 'r', ',', 'r', '0', 0 } },
    & ifmt_ldsrr0, { 0x9e9b }
  },
/* ld r0,sr */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'r', '0', ',', 's', 'r', 0 } },
    & ifmt_ldsrr0, { 0x9e9a }
  },
/* ld $Rn,$imm8 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', OP (IMM8), 0 } },
    & ifmt_ldi8, { 0x1000 }
  },
/* ld $Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_addgri16, { 0x8df0 }
  },
/* ld $An,$eimm22 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AN), ',', OP (EIMM22), 0 } },
    & ifmt_lda22, { 0xa880 }
  },
/* pop $Rlist */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RLIST), 0 } },
    & ifmt_popgr, { 0xa0e0 }
  },
/* pop $Alist */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (ALIST), 0 } },
    & ifmt_popar, { 0xa8e8 }
  },
/* ldc $Rn,@$Ai */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), ',', '@', OP (AI), 0 } },
    & ifmt_ldc, { 0xa000 }
  },
/* ldw @[$An2+$Rj],$Ri1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (AN2), '+', OP (RJ), ']', ',', OP (RI1), 0 } },
    & ifmt_stwaRj, { 0x5080 }
  },
/* ldw @[$Ai1+$Rj],$An */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (AI1), '+', OP (RJ), ']', ',', OP (AN), 0 } },
    & ifmt_ldaaRj, { 0x7880 }
  },
/* ldw @[$An2+$edisp5],$Ri1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (AN2), '+', OP (EDISP5), ']', ',', OP (RI1), 0 } },
    & ifmt_stwaedisp5, { 0x5000 }
  },
/* ldw @[$Ai1+$edisp5],$An */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (AI1), '+', OP (EDISP5), ']', ',', OP (AN), 0 } },
    & ifmt_ldaaedisp5, { 0x7800 }
  },
/* ldw @[$sp+$edisp9],$Ri1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (SP), '+', OP (EDISP9), ']', ',', OP (RI1), 0 } },
    & ifmt_stwspedisp9, { 0x3000 }
  },
/* ldw @[$An1+$disp16],$Ri1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (AN1), '+', OP (DISP16), ']', ',', OP (RI1), 0 } },
    & ifmt_stwadisp16, { 0xa028 }
  },
/* ldw @[$Ai+$disp16],$An */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (AI), '+', OP (DISP16), ']', ',', OP (AN), 0 } },
    & ifmt_ldw_ar_a_disp16, { 0xa838 }
  },
/* ldb @[$An2+$Rm],$Di */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (AN2), '+', OP (RM), ']', ',', OP (DI), 0 } },
    & ifmt_stbaRm, { 0x7080 }
  },
/* ldb @[$An2+$disp4],$Di */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (AN2), '+', OP (DISP4), ']', ',', OP (DI), 0 } },
    & ifmt_stbadisp4, { 0x7000 }
  },
/* ldb @[a8+$disp8],r0 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', 'a', '8', '+', OP (DISP8), ']', ',', 'r', '0', 0 } },
    & ifmt_ldba8disp8, { 0x9d00 }
  },
/* ldb @[$An1+$disp16],$Di */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', OP (AN1), '+', OP (DISP16), ']', ',', OP (DI), 0 } },
    & ifmt_stbadisp16, { 0xa038 }
  },
/* push $Rlist */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RLIST), 0 } },
    & ifmt_popgr, { 0xa0f0 }
  },
/* push $Alist */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (ALIST), 0 } },
    & ifmt_popar, { 0xa8f8 }
  },
/* bitr @[a8+r1],$bs3 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', 'a', '8', '+', 'r', '1', ']', ',', OP (BS3), 0 } },
    & ifmt_bitr, { 0x9e00 }
  },
/* bits @[a8+r1],$bs3 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', 'a', '8', '+', 'r', '1', ']', ',', OP (BS3), 0 } },
    & ifmt_bitr, { 0x9e08 }
  },
/* bitc @[a8+r1],$bs3 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', 'a', '8', '+', 'r', '1', ']', ',', OP (BS3), 0 } },
    & ifmt_bitr, { 0x9e10 }
  },
/* bitt @[a8+r1],$bs3 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', '@', '[', 'a', '8', '+', 'r', '1', ']', ',', OP (BS3), 0 } },
    & ifmt_bitr, { 0x9e18 }
  },
/* cmp ge,$Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'g', 'e', ',', OP (RN), ',', OP (RI), 0 } },
    & ifmt_cmpgegr, { 0x8080 }
  },
/* cmp gt,$Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'g', 't', ',', OP (RN), ',', OP (RI), 0 } },
    & ifmt_cmpgegr, { 0x8090 }
  },
/* cmp uge,$Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'u', 'g', 'e', ',', OP (RN), ',', OP (RI), 0 } },
    & ifmt_cmpgegr, { 0x80a0 }
  },
/* cmp ugt,$Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'u', 'g', 't', ',', OP (RN), ',', OP (RI), 0 } },
    & ifmt_cmpgegr, { 0x80b0 }
  },
/* cmp eq,$Rn,$Ri */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'e', 'q', ',', OP (RN), ',', OP (RI), 0 } },
    & ifmt_cmpgegr, { 0x80c0 }
  },
/* cmp ge,$Dn,$imm6 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'g', 'e', ',', OP (DN), ',', OP (IMM6), 0 } },
    & ifmt_cmpgegrimm6, { 0xa040 }
  },
/* cmp eq,$Dn,$imm8 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'e', 'q', ',', OP (DN), ',', OP (IMM8), 0 } },
    & ifmt_cmpeqgrimm8, { 0x9000 }
  },
/* cmp ge,$Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'g', 'e', ',', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_cmpgei16, { 0x88f0 }
  },
/* cmp gt,$Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'g', 't', ',', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_cmpgei16, { 0x89f0 }
  },
/* cmp uge,$Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'u', 'g', 'e', ',', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_cmpgei16, { 0x8af0 }
  },
/* cmp ugt,$Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'u', 'g', 't', ',', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_cmpgei16, { 0x8bf0 }
  },
/* cmp eq,$Rn1,$eimm16 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'e', 'q', ',', OP (RN1), ',', OP (EIMM16), 0 } },
    & ifmt_cmpgei16, { 0x8cf0 }
  },
/* cmp eq,$An,$Ai */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'e', 'q', ',', OP (AN), ',', OP (AI), 0 } },
    & ifmt_ldAnAi, { 0xa810 }
  },
/* cmp eq,$An,$eimm22 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', 'e', 'q', ',', OP (AN), ',', OP (EIMM22), 0 } },
    & ifmt_lda22, { 0xa080 }
  },
/* bra $ec2,$elabel8 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (EC2), ',', OP (ELABEL8), 0 } },
    & ifmt_braext, { 0xc000 }
  },
/* brad $ec2,$elabel8 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (EC2), ',', OP (ELABEL8), 0 } },
    & ifmt_braext, { 0xc400 }
  },
/* bra $elabel11 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (ELABEL11), 0 } },
    & ifmt_bra, { 0xc800 }
  },
/* brad $elabel11 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (ELABEL11), 0 } },
    & ifmt_bra, { 0xcc00 }
  },
/* brt $elabel11 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (ELABEL11), 0 } },
    & ifmt_bra, { 0xd800 }
  },
/* brtd $elabel11 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (ELABEL11), 0 } },
    & ifmt_bra, { 0xdc00 }
  },
/* brf $elabel11 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (ELABEL11), 0 } },
    & ifmt_bra, { 0xd000 }
  },
/* brfd $elabel11 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (ELABEL11), 0 } },
    & ifmt_bra, { 0xd400 }
  },
/* bnzd $H,$elabel8 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (H), ',', OP (ELABEL8), 0 } },
    & ifmt_bnzd, { 0xc600 }
  },
/* jpf $Ai */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AI), 0 } },
    & ifmt_jpfAi, { 0x86e0 }
  },
/* jpf $imm22 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (IMM22), 0 } },
    & ifmt_jpfimm22, { 0x9f00 }
  },
/* jpt $Ai */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AI), 0 } },
    & ifmt_jpfAi, { 0x86e8 }
  },
/* jpt $imm22 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (IMM22), 0 } },
    & ifmt_jpfimm22, { 0x9f40 }
  },
/* jmp $Ai */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AI), 0 } },
    & ifmt_jpfAi, { 0x87e0 }
  },
/* jmp $imm22 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (IMM22), 0 } },
    & ifmt_jmpimm22, { 0x9f80 }
  },
/* jsr $Ai */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (AI), 0 } },
    & ifmt_jpfAi, { 0x87e8 }
  },
/* jsr $imm22 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (IMM22), 0 } },
    & ifmt_jmpimm22, { 0x9fc0 }
  },
/* bsrd $elabel13 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (ELABEL13), 0 } },
    & ifmt_bsrd, { 0xb000 }
  },
/* retd */
  {
    { 0, 0, 0, 0 },
    { { MNEM, 0 } },
    & ifmt_ldsrr0, { 0x9e9f }
  },
/* swi $imm6 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (IMM6), 0 } },
    & ifmt_swi, { 0x9e40 }
  },
/* ret_fiq */
  {
    { 0, 0, 0, 0 },
    { { MNEM, 0 } },
    & ifmt_ldsrr0, { 0x9e9c }
  },
/* ret_irq */
  {
    { 0, 0, 0, 0 },
    { { MNEM, 0 } },
    & ifmt_ldsrr0, { 0x9e9d }
  },
/* ret_swi */
  {
    { 0, 0, 0, 0 },
    { { MNEM, 0 } },
    & ifmt_ldsrr0, { 0x9e9e }
  },
/* break */
  {
    { 0, 0, 0, 0 },
    { { MNEM, 0 } },
    & ifmt_ldsrr0, { 0x9e99 }
  },
/* nop */
  {
    { 0, 0, 0, 0 },
    { { MNEM, 0 } },
    & ifmt_ldsrr0, { 0x9e98 }
  },
/* cld $Dn1,$imm5c */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (DN1), ',', OP (IMM5C), 0 } },
    & ifmt_cldr, { 0xe000 }
  },
/* cld $imm5c,$Di1 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (IMM5C), ',', OP (DI1), 0 } },
    & ifmt_cldw, { 0xe008 }
  },
/* cop $imm13 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (IMM13), 0 } },
    & ifmt_cop, { 0xe000 }
  },
/* sys $imm5 */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (IMM5), 0 } },
    & ifmt_sys, { 0x9e20 }
  },
};

#undef A
#undef OPERAND
#undef MNEM
#undef OP

/* Formats for ALIAS macro-insns.  */

#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define F(f) & calmrisc16_cgen_ifld_table[CALMRISC16_##f]
#else
#define F(f) & calmrisc16_cgen_ifld_table[CALMRISC16_/**/f]
#endif
static const CGEN_IFMT ifmt_dec = {
  16, 16, 0xf0ff, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP8_1) }, { F (F_IMM7) }, { 0 } }
};

static const CGEN_IFMT ifmt_inc = {
  16, 16, 0xf0ff, { { F (F_OP1) }, { F (F_RN) }, { F (F_OP8_1) }, { F (F_IMM7) }, { 0 } }
};

#undef F

/* Each non-simple macro entry points to an array of expansion possibilities.  */

#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define A(a) (1 << CGEN_INSN_##a)
#else
#define A(a) (1 << CGEN_INSN_/**/a)
#endif
#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define OPERAND(op) CALMRISC16_OPERAND_##op
#else
#define OPERAND(op) CALMRISC16_OPERAND_/**/op
#endif
#define MNEM CGEN_SYNTAX_MNEMONIC /* syntax value for mnemonic */
#define OP(field) CGEN_SYNTAX_MAKE_FIELD (OPERAND (field))

/* The macro instruction table.  */

static const CGEN_IBASE calmrisc16_cgen_macro_insn_table[] =
{
/* dec $Rn */
  {
    -1, "dec", "dec", 16,
    { 0|A(NO_DIS)|A(ALIAS), { (1<<MACH_BASE) } }
  },
/* inc $Rn */
  {
    -1, "inc", "inc", 16,
    { 0|A(NO_DIS)|A(ALIAS), { (1<<MACH_BASE) } }
  },
};

/* The macro instruction opcode table.  */

static const CGEN_OPCODE calmrisc16_cgen_macro_insn_opcode_table[] =
{
/* dec $Rn */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), 0 } },
    & ifmt_dec, { 0x81 }
  },
/* inc $Rn */
  {
    { 0, 0, 0, 0 },
    { { MNEM, ' ', OP (RN), 0 } },
    & ifmt_inc, { 0x1 }
  },
};

#undef A
#undef OPERAND
#undef MNEM
#undef OP

#ifndef CGEN_ASM_HASH_P
#define CGEN_ASM_HASH_P(insn) 1
#endif

#ifndef CGEN_DIS_HASH_P
#define CGEN_DIS_HASH_P(insn) 1
#endif

/* Return non-zero if INSN is to be added to the hash table.
   Targets are free to override CGEN_{ASM,DIS}_HASH_P in the .opc file.  */

static int
asm_hash_insn_p (insn)
     const CGEN_INSN *insn;
{
  return CGEN_ASM_HASH_P (insn);
}

static int
dis_hash_insn_p (insn)
     const CGEN_INSN *insn;
{
  /* If building the hash table and the NO-DIS attribute is present,
     ignore.  */
  if (CGEN_INSN_ATTR_VALUE (insn, CGEN_INSN_NO_DIS))
    return 0;
  return CGEN_DIS_HASH_P (insn);
}

#ifndef CGEN_ASM_HASH
#define CGEN_ASM_HASH_SIZE 127
#ifdef CGEN_MNEMONIC_OPERANDS
#define CGEN_ASM_HASH(mnem) (*(unsigned char *) (mnem) % CGEN_ASM_HASH_SIZE)
#else
#define CGEN_ASM_HASH(mnem) (*(unsigned char *) (mnem) % CGEN_ASM_HASH_SIZE) /*FIXME*/
#endif
#endif

/* It doesn't make much sense to provide a default here,
   but while this is under development we do.
   BUFFER is a pointer to the bytes of the insn, target order.
   VALUE is the first base_insn_bitsize bits as an int in host order.  */

#ifndef CGEN_DIS_HASH
#define CGEN_DIS_HASH_SIZE 256
#define CGEN_DIS_HASH(buf, value) (*(unsigned char *) (buf))
#endif

/* The result is the hash value of the insn.
   Targets are free to override CGEN_{ASM,DIS}_HASH in the .opc file.  */

static unsigned int
asm_hash_insn (mnem)
     const char * mnem;
{
  return CGEN_ASM_HASH (mnem);
}

/* BUF is a pointer to the bytes of the insn, target order.
   VALUE is the first base_insn_bitsize bits as an int in host order.  */

static unsigned int
dis_hash_insn (buf, value)
     const char * buf;
     CGEN_INSN_INT value;
{
  return CGEN_DIS_HASH (buf, value);
}

/* Set the recorded length of the insn in the CGEN_FIELDS struct.  */

static void
set_fields_bitsize (fields, size)
     CGEN_FIELDS *fields;
     int size;
{
  CGEN_FIELDS_BITSIZE (fields) = size;
}

/* Function to call before using the operand instance table.
   This plugs the opcode entries and macro instructions into the cpu table.  */

void
calmrisc16_cgen_init_opcode_table (cd)
     CGEN_CPU_DESC cd;
{
  int i;
  int num_macros = (sizeof (calmrisc16_cgen_macro_insn_table) /
		    sizeof (calmrisc16_cgen_macro_insn_table[0]));
  const CGEN_IBASE *ib = & calmrisc16_cgen_macro_insn_table[0];
  const CGEN_OPCODE *oc = & calmrisc16_cgen_macro_insn_opcode_table[0];
  CGEN_INSN *insns = (CGEN_INSN *) xmalloc (num_macros * sizeof (CGEN_INSN));
  memset (insns, 0, num_macros * sizeof (CGEN_INSN));
  for (i = 0; i < num_macros; ++i)
    {
      insns[i].base = &ib[i];
      insns[i].opcode = &oc[i];
    }
  cd->macro_insn_table.init_entries = insns;
  cd->macro_insn_table.entry_size = sizeof (CGEN_IBASE);
  cd->macro_insn_table.num_init_entries = num_macros;

  oc = & calmrisc16_cgen_insn_opcode_table[0];
  insns = (CGEN_INSN *) cd->insn_table.init_entries;
  for (i = 0; i < MAX_INSNS; ++i)
    insns[i].opcode = &oc[i];

  cd->sizeof_fields = sizeof (CGEN_FIELDS);
  cd->set_fields_bitsize = set_fields_bitsize;

  cd->asm_hash_p = asm_hash_insn_p;
  cd->asm_hash = asm_hash_insn;
  cd->asm_hash_size = CGEN_ASM_HASH_SIZE;

  cd->dis_hash_p = dis_hash_insn_p;
  cd->dis_hash = dis_hash_insn;
  cd->dis_hash_size = CGEN_DIS_HASH_SIZE;
}
