/* Simulator model support for calmrisc16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define WANT_CPU calmrisc16bf
#define WANT_CPU_CALMRISC16BF

#include "sim-main.h"

/* The profiling data is recorded here, but is accessed via the profiling
   mechanism.  After all, this is information for profiling.  */

#if WITH_PROFILE_MODEL_P

/* Model handlers for each insn.  */

static int
model_calmrisc16_clrsrfe (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_setsrfe (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstsrfe (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_clrsrie (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_setsrie (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstsrie (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_clrsrte (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_setsrte (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstsrte (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_clrsrv (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_setsrv (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstsrv (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_clrsrz0 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_setsrz0 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstsrz0 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_clrsrz1 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_setsrz1 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstsrz1 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_clrsrpm (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_setsrpm (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstsrpm (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_addgrgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_subgrgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_addgrgrc (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_subgrgrc (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_muluu (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_muluu.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_mulus (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_muluu.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_mulsu (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_muluu.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_mulss (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_muluu.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_addgri7 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri7.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_subgri7 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri7.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_addgri16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_addgri16c (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_subgri16c (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_addargr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addargr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_subargr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addargr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_addari5 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari5.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_subari5 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari5.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_addari16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_subari16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_com (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_com2 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_comc (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_decc (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_incc (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_dt (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ext (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_rr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_sr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_sra (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_srb (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_slb (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_rrc (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_rl (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_andgrgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_orgrgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_xorgrgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstgrgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_andgri8 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_orgri8 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_xorgri8 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstgri8 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_andgri16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_orgri16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_xorgri16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_tstgri16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldwaRj (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldwaRj.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldaaRj (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldaaRj.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldwaedisp5 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldwaedisp5.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldaaedisp5 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldaaedisp5.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldwspedisp9 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldwspedisp9.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldw_gr_a_disp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_gr_a_disp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldw_ar_a_disp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_ar_a_disp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldbaRj (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldbaRj.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldbadisp4 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldbadisp4.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldba8disp8 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldba8disp8.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldbadisp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldbadisp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldEnDi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldEnDi.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldDnEi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldDnEi.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldRnRi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldAnAi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_ar_a_disp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldAnpc (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldr0srx (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldr0srx.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldsrxr0 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldsrxr0.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldsrr0 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldr0sr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldi8 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldi8.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldi16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_lda22 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_popgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_popgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_popar (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_popgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ldc (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_gr_a_disp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_stwaRj (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stwaRj.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_staaRj (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldaaRj.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_stwaedisp5 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stwaedisp5.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_staaedisp5 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldaaedisp5.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_stwspedisp9 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stwspedisp9.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_stwadisp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stwadisp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_stw_ar_a_disp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_ar_a_disp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_stbaRm (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stbaRm.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_stbadisp4 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stbadisp4.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_stba8disp8 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldba8disp8.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_stbadisp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stbadisp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_pushgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_popgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_pushar (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_popgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_bitr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bitr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_bits (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bitr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_bitc (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bitr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_bitt (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bitr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpgegr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpgtgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpugegr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpugtgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpeqgr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpgegrimm6 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpgegrimm6.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpeqgrimm8 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpgei16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpgti16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpugei16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpugti16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpeqi16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpeqarar (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_ar_a_disp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cmpeqa22 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_braext (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_bradext (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_bra (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_brad (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_brt (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_brtd (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_brf (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_brfd (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_bnzd (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bnzd.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_jpfAi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_jpfimm22 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_jptAi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_jptimm22 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_jmpAi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_jmpimm22 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_jsrAi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_jsrimm22 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_bsrd (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bsrd.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_retd (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_swi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpgegrimm6.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_retfiq (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_retirq (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_ret_swi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_break (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_nop (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cldr (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cldr.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cldw (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_cop (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_calmrisc16_sys (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += calmrisc16bf_model_calmrisc16_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

/* We assume UNIT_NONE == 0 because the tables don't always terminate
   entries with it.  */

/* Model timing data for `calmrisc16'.  */

static const INSN_TIMING calmrisc16_timing[] = {
  { CALMRISC16BF_INSN_X_INVALID, 0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_X_AFTER, 0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_X_BEFORE, 0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_X_CTI_CHAIN, 0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_X_CHAIN, 0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_X_BEGIN, 0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CLRSRFE, model_calmrisc16_clrsrfe, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SETSRFE, model_calmrisc16_setsrfe, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTSRFE, model_calmrisc16_tstsrfe, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CLRSRIE, model_calmrisc16_clrsrie, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SETSRIE, model_calmrisc16_setsrie, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTSRIE, model_calmrisc16_tstsrie, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CLRSRTE, model_calmrisc16_clrsrte, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SETSRTE, model_calmrisc16_setsrte, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTSRTE, model_calmrisc16_tstsrte, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CLRSRV, model_calmrisc16_clrsrv, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SETSRV, model_calmrisc16_setsrv, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTSRV, model_calmrisc16_tstsrv, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CLRSRZ0, model_calmrisc16_clrsrz0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SETSRZ0, model_calmrisc16_setsrz0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTSRZ0, model_calmrisc16_tstsrz0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CLRSRZ1, model_calmrisc16_clrsrz1, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SETSRZ1, model_calmrisc16_setsrz1, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTSRZ1, model_calmrisc16_tstsrz1, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CLRSRPM, model_calmrisc16_clrsrpm, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SETSRPM, model_calmrisc16_setsrpm, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTSRPM, model_calmrisc16_tstsrpm, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ADDGRGR, model_calmrisc16_addgrgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SUBGRGR, model_calmrisc16_subgrgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ADDGRGRC, model_calmrisc16_addgrgrc, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SUBGRGRC, model_calmrisc16_subgrgrc, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_MULUU, model_calmrisc16_muluu, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_MULUS, model_calmrisc16_mulus, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_MULSU, model_calmrisc16_mulsu, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_MULSS, model_calmrisc16_mulss, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ADDGRI7, model_calmrisc16_addgri7, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SUBGRI7, model_calmrisc16_subgri7, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ADDGRI16, model_calmrisc16_addgri16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ADDGRI16C, model_calmrisc16_addgri16c, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SUBGRI16C, model_calmrisc16_subgri16c, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ADDARGR, model_calmrisc16_addargr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SUBARGR, model_calmrisc16_subargr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ADDARI5, model_calmrisc16_addari5, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SUBARI5, model_calmrisc16_subari5, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ADDARI16, model_calmrisc16_addari16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SUBARI16, model_calmrisc16_subari16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_COM, model_calmrisc16_com, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_COM2, model_calmrisc16_com2, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_COMC, model_calmrisc16_comc, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_DECC, model_calmrisc16_decc, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_INCC, model_calmrisc16_incc, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_DT, model_calmrisc16_dt, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_EXT, model_calmrisc16_ext, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_RR, model_calmrisc16_rr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SR, model_calmrisc16_sr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SRA, model_calmrisc16_sra, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SRB, model_calmrisc16_srb, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SLB, model_calmrisc16_slb, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_RRC, model_calmrisc16_rrc, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_RL, model_calmrisc16_rl, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ANDGRGR, model_calmrisc16_andgrgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ORGRGR, model_calmrisc16_orgrgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_XORGRGR, model_calmrisc16_xorgrgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTGRGR, model_calmrisc16_tstgrgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ANDGRI8, model_calmrisc16_andgri8, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ORGRI8, model_calmrisc16_orgri8, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_XORGRI8, model_calmrisc16_xorgri8, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTGRI8, model_calmrisc16_tstgri8, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ANDGRI16, model_calmrisc16_andgri16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_ORGRI16, model_calmrisc16_orgri16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_XORGRI16, model_calmrisc16_xorgri16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_TSTGRI16, model_calmrisc16_tstgri16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDWARJ, model_calmrisc16_ldwaRj, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDAARJ, model_calmrisc16_ldaaRj, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDWAEDISP5, model_calmrisc16_ldwaedisp5, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDAAEDISP5, model_calmrisc16_ldaaedisp5, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDWSPEDISP9, model_calmrisc16_ldwspedisp9, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDW_GR_A_DISP16, model_calmrisc16_ldw_gr_a_disp16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDW_AR_A_DISP16, model_calmrisc16_ldw_ar_a_disp16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDBARJ, model_calmrisc16_ldbaRj, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDBADISP4, model_calmrisc16_ldbadisp4, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDBA8DISP8, model_calmrisc16_ldba8disp8, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDBADISP16, model_calmrisc16_ldbadisp16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDENDI, model_calmrisc16_ldEnDi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDDNEI, model_calmrisc16_ldDnEi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDRNRI, model_calmrisc16_ldRnRi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDANAI, model_calmrisc16_ldAnAi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDANPC, model_calmrisc16_ldAnpc, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDR0SRX, model_calmrisc16_ldr0srx, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDSRXR0, model_calmrisc16_ldsrxr0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDSRR0, model_calmrisc16_ldsrr0, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDR0SR, model_calmrisc16_ldr0sr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDI8, model_calmrisc16_ldi8, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDI16, model_calmrisc16_ldi16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDA22, model_calmrisc16_lda22, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_POPGR, model_calmrisc16_popgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_POPAR, model_calmrisc16_popar, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_LDC, model_calmrisc16_ldc, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STWARJ, model_calmrisc16_stwaRj, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STAARJ, model_calmrisc16_staaRj, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STWAEDISP5, model_calmrisc16_stwaedisp5, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STAAEDISP5, model_calmrisc16_staaedisp5, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STWSPEDISP9, model_calmrisc16_stwspedisp9, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STWADISP16, model_calmrisc16_stwadisp16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STW_AR_A_DISP16, model_calmrisc16_stw_ar_a_disp16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STBARM, model_calmrisc16_stbaRm, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STBADISP4, model_calmrisc16_stbadisp4, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STBA8DISP8, model_calmrisc16_stba8disp8, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_STBADISP16, model_calmrisc16_stbadisp16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_PUSHGR, model_calmrisc16_pushgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_PUSHAR, model_calmrisc16_pushar, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BITR, model_calmrisc16_bitr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BITS, model_calmrisc16_bits, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BITC, model_calmrisc16_bitc, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BITT, model_calmrisc16_bitt, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPGEGR, model_calmrisc16_cmpgegr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPGTGR, model_calmrisc16_cmpgtgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPUGEGR, model_calmrisc16_cmpugegr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPUGTGR, model_calmrisc16_cmpugtgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPEQGR, model_calmrisc16_cmpeqgr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPGEGRIMM6, model_calmrisc16_cmpgegrimm6, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPEQGRIMM8, model_calmrisc16_cmpeqgrimm8, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPGEI16, model_calmrisc16_cmpgei16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPGTI16, model_calmrisc16_cmpgti16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPUGEI16, model_calmrisc16_cmpugei16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPUGTI16, model_calmrisc16_cmpugti16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPEQI16, model_calmrisc16_cmpeqi16, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPEQARAR, model_calmrisc16_cmpeqarar, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CMPEQA22, model_calmrisc16_cmpeqa22, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BRAEXT, model_calmrisc16_braext, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BRADEXT, model_calmrisc16_bradext, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BRA, model_calmrisc16_bra, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BRAD, model_calmrisc16_brad, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BRT, model_calmrisc16_brt, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BRTD, model_calmrisc16_brtd, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BRF, model_calmrisc16_brf, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BRFD, model_calmrisc16_brfd, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BNZD, model_calmrisc16_bnzd, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_JPFAI, model_calmrisc16_jpfAi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_JPFIMM22, model_calmrisc16_jpfimm22, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_JPTAI, model_calmrisc16_jptAi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_JPTIMM22, model_calmrisc16_jptimm22, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_JMPAI, model_calmrisc16_jmpAi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_JMPIMM22, model_calmrisc16_jmpimm22, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_JSRAI, model_calmrisc16_jsrAi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_JSRIMM22, model_calmrisc16_jsrimm22, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BSRD, model_calmrisc16_bsrd, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_RETD, model_calmrisc16_retd, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SWI, model_calmrisc16_swi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_RETFIQ, model_calmrisc16_retfiq, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_RETIRQ, model_calmrisc16_retirq, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_RET_SWI, model_calmrisc16_ret_swi, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_BREAK, model_calmrisc16_break, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_NOP, model_calmrisc16_nop, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CLDR, model_calmrisc16_cldr, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_CLDW, model_calmrisc16_cldw, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_COP, model_calmrisc16_cop, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
  { CALMRISC16BF_INSN_SYS, model_calmrisc16_sys, { { (int) UNIT_CALMRISC16_U_EXEC, 1, 1 } } },
};

#endif /* WITH_PROFILE_MODEL_P */

static void
calmrisc16_model_init (SIM_CPU *cpu)
{
  CPU_MODEL_DATA (cpu) = (void *) zalloc (sizeof (MODEL_CALMRISC16_DATA));
}

#if WITH_PROFILE_MODEL_P
#define TIMING_DATA(td) td
#else
#define TIMING_DATA(td) 0
#endif

static const MODEL calmrisc16_models[] =
{
  { "calmrisc16", & calmrisc16_mach, MODEL_CALMRISC16, TIMING_DATA (& calmrisc16_timing[0]), calmrisc16_model_init },
  { 0 }
};

/* The properties of this cpu's implementation.  */

static const MACH_IMP_PROPERTIES calmrisc16bf_imp_properties =
{
  sizeof (SIM_CPU),
#if WITH_SCACHE
  sizeof (SCACHE)
#else
  0
#endif
};


static void
calmrisc16bf_prepare_run (SIM_CPU *cpu)
{
  if (CPU_IDESC (cpu) == NULL)
    calmrisc16bf_init_idesc_table (cpu);
}

static const CGEN_INSN *
calmrisc16bf_get_idata (SIM_CPU *cpu, int inum)
{
  return CPU_IDESC (cpu) [inum].idata;
}

static void
calmrisc16_init_cpu (SIM_CPU *cpu)
{
  CPU_REG_FETCH (cpu) = calmrisc16bf_fetch_register;
  CPU_REG_STORE (cpu) = calmrisc16bf_store_register;
  CPU_PC_FETCH (cpu) = calmrisc16bf_h_pc_get;
  CPU_PC_STORE (cpu) = calmrisc16bf_h_pc_set;
  CPU_GET_IDATA (cpu) = calmrisc16bf_get_idata;
  CPU_MAX_INSNS (cpu) = CALMRISC16BF_INSN_MAX;
  CPU_INSN_NAME (cpu) = cgen_insn_name;
  CPU_FULL_ENGINE_FN (cpu) = calmrisc16bf_engine_run_full;
#if WITH_FAST
  CPU_FAST_ENGINE_FN (cpu) = calmrisc16bf_engine_run_fast;
#else
  CPU_FAST_ENGINE_FN (cpu) = calmrisc16bf_engine_run_full;
#endif
}

const MACH calmrisc16_mach =
{
  "calmrisc16", "calmrisc16", MACH_CALMRISC16,
  16, 16, & calmrisc16_models[0], & calmrisc16bf_imp_properties,
  calmrisc16_init_cpu,
  calmrisc16bf_prepare_run
};

