/* Misc. support for CPU family calmrisc16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define WANT_CPU calmrisc16bf
#define WANT_CPU_CALMRISC16BF

#include "sim-main.h"
#include "cgen-ops.h"

/* Get the value of h-pc.  */

USI
calmrisc16bf_h_pc_get (SIM_CPU *current_cpu)
{
  return CPU (h_pc);
}

/* Set a value for h-pc.  */

void
calmrisc16bf_h_pc_set (SIM_CPU *current_cpu, USI newval)
{
  CPU (h_pc) = newval;
}

/* Get the value of h-gr.  */

HI
calmrisc16bf_h_gr_get (SIM_CPU *current_cpu, UINT regno)
{
  return CPU (h_gr[regno]);
}

/* Set a value for h-gr.  */

void
calmrisc16bf_h_gr_set (SIM_CPU *current_cpu, UINT regno, HI newval)
{
  CPU (h_gr[regno]) = newval;
}

/* Get the value of h-r0.  */

HI
calmrisc16bf_h_r0_get (SIM_CPU *current_cpu)
{
  return GET_H_R0 ();
}

/* Set a value for h-r0.  */

void
calmrisc16bf_h_r0_set (SIM_CPU *current_cpu, HI newval)
{
  SET_H_R0 (newval);
}

/* Get the value of h-r1.  */

HI
calmrisc16bf_h_r1_get (SIM_CPU *current_cpu)
{
  return GET_H_R1 ();
}

/* Set a value for h-r1.  */

void
calmrisc16bf_h_r1_set (SIM_CPU *current_cpu, HI newval)
{
  SET_H_R1 (newval);
}

/* Get the value of h-er.  */

HI
calmrisc16bf_h_er_get (SIM_CPU *current_cpu, UINT regno)
{
  return CPU (h_er[regno]);
}

/* Set a value for h-er.  */

void
calmrisc16bf_h_er_set (SIM_CPU *current_cpu, UINT regno, HI newval)
{
  SET_H_ER (regno, newval);
}

/* Get the value of h-ar.  */

USI
calmrisc16bf_h_ar_get (SIM_CPU *current_cpu, UINT regno)
{
  return GET_H_AR (regno);
}

/* Set a value for h-ar.  */

void
calmrisc16bf_h_ar_set (SIM_CPU *current_cpu, UINT regno, USI newval)
{
  SET_H_AR (regno, newval);
}

/* Get the value of h-a8.  */

USI
calmrisc16bf_h_a8_get (SIM_CPU *current_cpu)
{
  return GET_H_A8 ();
}

/* Set a value for h-a8.  */

void
calmrisc16bf_h_a8_set (SIM_CPU *current_cpu, USI newval)
{
  SET_H_A8 (newval);
}

/* Get the value of h-a14.  */

USI
calmrisc16bf_h_a14_get (SIM_CPU *current_cpu)
{
  return GET_H_A14 ();
}

/* Set a value for h-a14.  */

void
calmrisc16bf_h_a14_set (SIM_CPU *current_cpu, USI newval)
{
  SET_H_A14 (newval);
}

/* Get the value of h-a15.  */

USI
calmrisc16bf_h_a15_get (SIM_CPU *current_cpu)
{
  return GET_H_A15 ();
}

/* Set a value for h-a15.  */

void
calmrisc16bf_h_a15_set (SIM_CPU *current_cpu, USI newval)
{
  SET_H_A15 (newval);
}

/* Get the value of h-spr.  */

UHI
calmrisc16bf_h_spr_get (SIM_CPU *current_cpu, UINT regno)
{
  return CPU (h_spr[regno]);
}

/* Set a value for h-spr.  */

void
calmrisc16bf_h_spr_set (SIM_CPU *current_cpu, UINT regno, UHI newval)
{
  CPU (h_spr[regno]) = newval;
}

/* Get the value of h-spcl-fiq.  */

UHI
calmrisc16bf_h_spcl_fiq_get (SIM_CPU *current_cpu)
{
  return GET_H_SPCL_FIQ ();
}

/* Set a value for h-spcl-fiq.  */

void
calmrisc16bf_h_spcl_fiq_set (SIM_CPU *current_cpu, UHI newval)
{
  SET_H_SPCL_FIQ (newval);
}

/* Get the value of h-spch-fiq.  */

UHI
calmrisc16bf_h_spch_fiq_get (SIM_CPU *current_cpu)
{
  return GET_H_SPCH_FIQ ();
}

/* Set a value for h-spch-fiq.  */

void
calmrisc16bf_h_spch_fiq_set (SIM_CPU *current_cpu, UHI newval)
{
  SET_H_SPCH_FIQ (newval);
}

/* Get the value of h-ssr-fiq.  */

UHI
calmrisc16bf_h_ssr_fiq_get (SIM_CPU *current_cpu)
{
  return GET_H_SSR_FIQ ();
}

/* Set a value for h-ssr-fiq.  */

void
calmrisc16bf_h_ssr_fiq_set (SIM_CPU *current_cpu, UHI newval)
{
  SET_H_SSR_FIQ (newval);
}

/* Get the value of h-spcl-irq.  */

UHI
calmrisc16bf_h_spcl_irq_get (SIM_CPU *current_cpu)
{
  return GET_H_SPCL_IRQ ();
}

/* Set a value for h-spcl-irq.  */

void
calmrisc16bf_h_spcl_irq_set (SIM_CPU *current_cpu, UHI newval)
{
  SET_H_SPCL_IRQ (newval);
}

/* Get the value of h-spch-irq.  */

UHI
calmrisc16bf_h_spch_irq_get (SIM_CPU *current_cpu)
{
  return GET_H_SPCH_IRQ ();
}

/* Set a value for h-spch-irq.  */

void
calmrisc16bf_h_spch_irq_set (SIM_CPU *current_cpu, UHI newval)
{
  SET_H_SPCH_IRQ (newval);
}

/* Get the value of h-ssr-irq.  */

UHI
calmrisc16bf_h_ssr_irq_get (SIM_CPU *current_cpu)
{
  return GET_H_SSR_IRQ ();
}

/* Set a value for h-ssr-irq.  */

void
calmrisc16bf_h_ssr_irq_set (SIM_CPU *current_cpu, UHI newval)
{
  SET_H_SSR_IRQ (newval);
}

/* Get the value of h-ssr-swi.  */

UHI
calmrisc16bf_h_ssr_swi_get (SIM_CPU *current_cpu)
{
  return GET_H_SSR_SWI ();
}

/* Set a value for h-ssr-swi.  */

void
calmrisc16bf_h_ssr_swi_set (SIM_CPU *current_cpu, UHI newval)
{
  SET_H_SSR_SWI (newval);
}

/* Get the value of h-t.  */

BI
calmrisc16bf_h_t_get (SIM_CPU *current_cpu)
{
  return CPU (h_t);
}

/* Set a value for h-t.  */

void
calmrisc16bf_h_t_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_t) = newval;
}

/* Get the value of h-z1.  */

BI
calmrisc16bf_h_z1_get (SIM_CPU *current_cpu)
{
  return CPU (h_z1);
}

/* Set a value for h-z1.  */

void
calmrisc16bf_h_z1_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_z1) = newval;
}

/* Get the value of h-z0.  */

BI
calmrisc16bf_h_z0_get (SIM_CPU *current_cpu)
{
  return CPU (h_z0);
}

/* Set a value for h-z0.  */

void
calmrisc16bf_h_z0_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_z0) = newval;
}

/* Get the value of h-v.  */

BI
calmrisc16bf_h_v_get (SIM_CPU *current_cpu)
{
  return CPU (h_v);
}

/* Set a value for h-v.  */

void
calmrisc16bf_h_v_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_v) = newval;
}

/* Get the value of h-pm.  */

BI
calmrisc16bf_h_pm_get (SIM_CPU *current_cpu)
{
  return CPU (h_pm);
}

/* Set a value for h-pm.  */

void
calmrisc16bf_h_pm_set (SIM_CPU *current_cpu, BI newval)
{
  SET_H_PM (newval);
}

/* Get the value of h-te.  */

BI
calmrisc16bf_h_te_get (SIM_CPU *current_cpu)
{
  return CPU (h_te);
}

/* Set a value for h-te.  */

void
calmrisc16bf_h_te_set (SIM_CPU *current_cpu, BI newval)
{
  SET_H_TE (newval);
}

/* Get the value of h-ie.  */

BI
calmrisc16bf_h_ie_get (SIM_CPU *current_cpu)
{
  return CPU (h_ie);
}

/* Set a value for h-ie.  */

void
calmrisc16bf_h_ie_set (SIM_CPU *current_cpu, BI newval)
{
  SET_H_IE (newval);
}

/* Get the value of h-fe.  */

BI
calmrisc16bf_h_fe_get (SIM_CPU *current_cpu)
{
  return CPU (h_fe);
}

/* Set a value for h-fe.  */

void
calmrisc16bf_h_fe_set (SIM_CPU *current_cpu, BI newval)
{
  SET_H_FE (newval);
}

/* Get the value of h-sr.  */

HI
calmrisc16bf_h_sr_get (SIM_CPU *current_cpu)
{
  return GET_H_SR ();
}

/* Set a value for h-sr.  */

void
calmrisc16bf_h_sr_set (SIM_CPU *current_cpu, HI newval)
{
  SET_H_SR (newval);
}

/* Get the value of h-ec2.  */

USI
calmrisc16bf_h_ec2_get (SIM_CPU *current_cpu)
{
  return GET_H_EC2 ();
}

/* Set a value for h-ec2.  */

void
calmrisc16bf_h_ec2_set (SIM_CPU *current_cpu, USI newval)
{
  SET_H_EC2 (newval);
}

/* Record trace results for INSN.  */

void
calmrisc16bf_record_trace_results (SIM_CPU *current_cpu, CGEN_INSN *insn,
			    int *indices, TRACE_RECORD *tr)
{
}
