/* Simulator instruction semantics for calmrisc16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define WANT_CPU calmrisc16bf
#define WANT_CPU_CALMRISC16BF

#include "sim-main.h"
#include "cgen-mem.h"
#include "cgen-ops.h"

#undef GET_ATTR
#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define GET_ATTR(cpu, num, attr) CGEN_ATTR_VALUE (NULL, abuf->idesc->attrs, CGEN_INSN_##attr)
#else
#define GET_ATTR(cpu, num, attr) CGEN_ATTR_VALUE (NULL, abuf->idesc->attrs, CGEN_INSN_/**/attr)
#endif

/* This is used so that we can compile two copies of the semantic code,
   one with full feature support and one without that runs fast(er).
   FAST_P, when desired, is defined on the command line, -DFAST_P=1.  */
#if FAST_P
#define SEM_FN_NAME(cpu,fn) XCONCAT3 (cpu,_semf_,fn)
#undef TRACE_RESULT
#define TRACE_RESULT(cpu, abuf, name, type, val)
#else
#define SEM_FN_NAME(cpu,fn) XCONCAT3 (cpu,_sem_,fn)
#endif

/* x-invalid: --invalid-- */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,x_invalid) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
    /* Update the recorded pc in the cpu state struct.
       Only necessary for WITH_SCACHE case, but to avoid the
       conditional compilation ....  */
    SET_H_PC (pc);
    /* Virtual insns have zero size.  Overwrite vpc with address of next insn
       using the default-insn-bitsize spec.  When executing insns in parallel
       we may want to queue the fault and continue execution.  */
    vpc = SEM_NEXT_VPC (sem_arg, pc, 2);
    vpc = sim_engine_invalid_insn (current_cpu, pc, vpc);
  }

  return vpc;
#undef FLD
}

/* x-after: --after-- */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,x_after) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_CALMRISC16BF
    calmrisc16bf_pbb_after (current_cpu, sem_arg);
#endif
  }

  return vpc;
#undef FLD
}

/* x-before: --before-- */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,x_before) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_CALMRISC16BF
    calmrisc16bf_pbb_before (current_cpu, sem_arg);
#endif
  }

  return vpc;
#undef FLD
}

/* x-cti-chain: --cti-chain-- */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,x_cti_chain) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_CALMRISC16BF
#ifdef DEFINE_SWITCH
    vpc = calmrisc16bf_pbb_cti_chain (current_cpu, sem_arg,
			       pbb_br_type, pbb_br_npc);
    BREAK (sem);
#else
    /* FIXME: Allow provision of explicit ifmt spec in insn spec.  */
    vpc = calmrisc16bf_pbb_cti_chain (current_cpu, sem_arg,
			       CPU_PBB_BR_TYPE (current_cpu),
			       CPU_PBB_BR_NPC (current_cpu));
#endif
#endif
  }

  return vpc;
#undef FLD
}

/* x-chain: --chain-- */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,x_chain) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_CALMRISC16BF
    vpc = calmrisc16bf_pbb_chain (current_cpu, sem_arg);
#ifdef DEFINE_SWITCH
    BREAK (sem);
#endif
#endif
  }

  return vpc;
#undef FLD
}

/* x-begin: --begin-- */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,x_begin) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_CALMRISC16BF
#if defined DEFINE_SWITCH || defined FAST_P
    /* In the switch case FAST_P is a constant, allowing several optimizations
       in any called inline functions.  */
    vpc = calmrisc16bf_pbb_begin (current_cpu, FAST_P);
#else
#if 0 /* cgen engine can't handle dynamic fast/full switching yet.  */
    vpc = calmrisc16bf_pbb_begin (current_cpu, STATE_RUN_FAST_P (CPU_STATE (current_cpu)));
#else
    vpc = calmrisc16bf_pbb_begin (current_cpu, 0);
#endif
#endif
#endif
  }

  return vpc;
#undef FLD
}

/* clrsrfe: clrsr fe */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,clrsrfe) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 0;
    SET_H_FE (opval);
    TRACE_RESULT (current_cpu, abuf, "fe", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* setsrfe: setsr fe */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,setsrfe) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 1;
    SET_H_FE (opval);
    TRACE_RESULT (current_cpu, abuf, "fe", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* tstsrfe: tstsr fe */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstsrfe) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = NOTBI (CPU (h_fe));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* clrsrie: clrsr ie */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,clrsrie) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 0;
    SET_H_IE (opval);
    TRACE_RESULT (current_cpu, abuf, "ie", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* setsrie: setsr ie */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,setsrie) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 1;
    SET_H_IE (opval);
    TRACE_RESULT (current_cpu, abuf, "ie", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* tstsrie: tstsr ie */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstsrie) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = NOTBI (CPU (h_ie));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* clrsrte: clrsr te */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,clrsrte) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 0;
    SET_H_TE (opval);
    TRACE_RESULT (current_cpu, abuf, "te", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* setsrte: setsr te */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,setsrte) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 1;
    SET_H_TE (opval);
    TRACE_RESULT (current_cpu, abuf, "te", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* tstsrte: tstsr te */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstsrte) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = NOTBI (CPU (h_te));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* clrsrv: clrsr v */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,clrsrv) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 0;
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* setsrv: setsr v */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,setsrv) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 1;
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* tstsrv: tstsr v */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstsrv) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = NOTBI (CPU (h_v));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* clrsrz0: clrsr z0 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,clrsrz0) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 0;
    CPU (h_z0) = opval;
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* setsrz0: setsr z0 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,setsrz0) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 1;
    CPU (h_z0) = opval;
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* tstsrz0: tstsr z0 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstsrz0) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = NOTBI (CPU (h_z0));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* clrsrz1: clrsr z1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,clrsrz1) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 0;
    CPU (h_z1) = opval;
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* setsrz1: setsr z1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,setsrz1) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 1;
    CPU (h_z1) = opval;
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* tstsrz1: tstsr z1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstsrz1) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = NOTBI (CPU (h_z1));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* clrsrpm: clrsr pm */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,clrsrpm) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 0;
    SET_H_PM (opval);
    TRACE_RESULT (current_cpu, abuf, "pm", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* setsrpm: setsr pm */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,setsrpm) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = 1;
    SET_H_PM (opval);
    TRACE_RESULT (current_cpu, abuf, "pm", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* tstsrpm: tstsr pm */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstsrpm) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = NOTBI (CPU (h_pm));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* addgrgr: add $Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,addgrgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = ADDOFHI (* FLD (i_Rn), * FLD (i_Ri), 0);
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = ADDCFHI (* FLD (i_Rn), * FLD (i_Ri), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = ADDHI (* FLD (i_Rn), * FLD (i_Ri));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* subgrgr: sub $Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,subgrgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = SUBOFHI (* FLD (i_Rn), * FLD (i_Ri), 0);
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = NOTHI (SUBCFHI (* FLD (i_Rn), * FLD (i_Ri), 0));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = SUBHI (* FLD (i_Rn), * FLD (i_Ri));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* addgrgrc: adc $Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,addgrgrc) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  tmp_tmp = ADDCHI (* FLD (i_Rn), * FLD (i_Ri), CPU (h_t));
  {
    BI opval = ADDOFHI (* FLD (i_Rn), * FLD (i_Ri), CPU (h_t));
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = ADDCFHI (* FLD (i_Rn), * FLD (i_Ri), CPU (h_t));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = tmp_tmp;
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 8);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* subgrgrc: sbc $Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,subgrgrc) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  tmp_tmp = SUBCHI (* FLD (i_Rn), * FLD (i_Ri), NOTBI (CPU (h_t)));
  {
    BI opval = SUBOFHI (* FLD (i_Rn), * FLD (i_Ri), NOTBI (CPU (h_t)));
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = NOTHI (SUBCFHI (* FLD (i_Rn), * FLD (i_Ri), NOTBI (CPU (h_t))));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = tmp_tmp;
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 8);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* muluu: mul uu,$Dn,$Di1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,muluu) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_muluu.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = MULHI (ANDHI (* FLD (i_Dn), 255), ANDHI (* FLD (i_Di1), 255));
    * FLD (i_Dn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Dn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* mulus: mul us,$Dn,$Di1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,mulus) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_muluu.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = MULHI (ANDHI (* FLD (i_Dn), 255), TRUNCHIQI (* FLD (i_Di1)));
    * FLD (i_Dn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Dn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* mulsu: mul su,$Dn,$Di1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,mulsu) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_muluu.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = MULQI (TRUNCHIQI (* FLD (i_Dn)), ANDHI (* FLD (i_Di1), 255));
    * FLD (i_Dn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Dn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* mulss: mul ss,$Dn,$Di1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,mulss) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_muluu.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = MULQI (TRUNCHIQI (* FLD (i_Dn)), TRUNCHIQI (* FLD (i_Di1)));
    * FLD (i_Dn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Dn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* addgri7: add $Rn,$imm7 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,addgri7) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri7.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = ADDOFHI (* FLD (i_Rn), FLD (f_imm7), 0);
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = ADDCFHI (* FLD (i_Rn), FLD (f_imm7), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = ADDHI (* FLD (i_Rn), FLD (f_imm7));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* subgri7: sub $Rn,$imm7 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,subgri7) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri7.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = SUBOFHI (* FLD (i_Rn), FLD (f_imm7), 0);
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = NOTHI (SUBCFHI (* FLD (i_Rn), FLD (f_imm7), 0));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = SUBHI (* FLD (i_Rn), FLD (f_imm7));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* addgri16: add $Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,addgri16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  {
    BI opval = ADDOFHI (* FLD (i_Rn1), FLD (f_imm16), 0);
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = ADDCFHI (* FLD (i_Rn1), FLD (f_imm16), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = ADDHI (* FLD (i_Rn1), FLD (f_imm16));
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* addgri16c: adc $Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,addgri16c) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  HI tmp_tmp;
  tmp_tmp = ADDCHI (* FLD (i_Rn1), FLD (f_imm16), CPU (h_t));
  {
    BI opval = ADDOFHI (* FLD (i_Rn1), FLD (f_imm16), CPU (h_t));
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = ADDCFHI (* FLD (i_Rn1), FLD (f_imm16), CPU (h_t));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = tmp_tmp;
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 8);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* subgri16c: sbc $Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,subgri16c) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  HI tmp_tmp;
  tmp_tmp = SUBCHI (* FLD (i_Rn1), FLD (f_imm16), NOTBI (CPU (h_t)));
  {
    BI opval = SUBOFHI (* FLD (i_Rn1), FLD (f_imm16), NOTBI (CPU (h_t)));
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = NOTHI (SUBCFHI (* FLD (i_Rn1), FLD (f_imm16), NOTBI (CPU (h_t))));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = tmp_tmp;
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 8);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* addargr: add $An,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,addargr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addargr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    USI opval = ADDSI (GET_H_AR (FLD (f_An)), ZEXTHISI (* FLD (i_Ri)));
    SET_H_AR (FLD (f_An), opval);
    TRACE_RESULT (current_cpu, abuf, "An", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* subargr: sub $An,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,subargr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addargr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    USI opval = SUBSI (GET_H_AR (FLD (f_An)), ZEXTHISI (* FLD (i_Ri)));
    SET_H_AR (FLD (f_An), opval);
    TRACE_RESULT (current_cpu, abuf, "An", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* addari5: add $An,$imm5 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,addari5) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari5.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    USI opval = ADDSI (GET_H_AR (FLD (f_An)), FLD (f_imm5));
    SET_H_AR (FLD (f_An), opval);
    TRACE_RESULT (current_cpu, abuf, "An", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* subari5: sub $An,$imm5 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,subari5) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari5.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    USI opval = SUBSI (GET_H_AR (FLD (f_An)), FLD (f_imm5));
    SET_H_AR (FLD (f_An), opval);
    TRACE_RESULT (current_cpu, abuf, "An", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* addari16: add $An1,$imm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,addari16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    USI opval = ADDSI (GET_H_AR (FLD (f_An1)), FLD (f_imm16));
    SET_H_AR (FLD (f_An1), opval);
    TRACE_RESULT (current_cpu, abuf, "An1", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* subari16: sub $An1,$imm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,subari16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    USI opval = SUBSI (GET_H_AR (FLD (f_An1)), FLD (f_imm16));
    SET_H_AR (FLD (f_An1), opval);
    TRACE_RESULT (current_cpu, abuf, "An1", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* com: com $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,com) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = INVHI (* FLD (i_Rn1));
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 4);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* com2: com2 $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,com2) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = INVHI (* FLD (i_Rn1));
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
  {
    BI opval = ADDCFHI (* FLD (i_Rn1), 1, 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = ADDHI (* FLD (i_Rn1), 1);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 4);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* comc: comc $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,comc) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  {
    HI opval = INVHI (* FLD (i_Rn1));
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
  tmp_tmp = ADDHI (* FLD (i_Rn1), CPU (h_t));
  {
    BI opval = ADDCFHI (* FLD (i_Rn1), CPU (h_t), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = tmp_tmp;
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* decc: decc $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,decc) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  tmp_tmp = SUBCHI (* FLD (i_Rn1), 0, NOTBI (CPU (h_t)));
  {
    BI opval = SUBOFHI (* FLD (i_Rn1), 0, NOTBI (CPU (h_t)));
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = NOTHI (SUBCFHI (* FLD (i_Rn1), 0, NOTBI (CPU (h_t))));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = tmp_tmp;
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* incc: incc $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,incc) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  tmp_tmp = ADDCHI (* FLD (i_Rn1), 0, CPU (h_t));
  {
    BI opval = ADDOFHI (* FLD (i_Rn1), 0, CPU (h_t));
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    BI opval = ADDCFHI (* FLD (i_Rn1), 0, CPU (h_t));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = tmp_tmp;
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* dt: dt $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,dt) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = SUBOFHI (* FLD (i_Rn1), 1, 0);
    CPU (h_v) = opval;
    TRACE_RESULT (current_cpu, abuf, "v", 'x', opval);
  }
  {
    HI opval = SUBHI (* FLD (i_Rn1), 1);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* ext: ext $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ext) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = EXTQIHI (TRUNCHIQI (* FLD (i_Rn1)));
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 4);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* rr: rr $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,rr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = ANDHI (* FLD (i_Rn1), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = RORHI (* FLD (i_Rn1), 1);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* sr: sr $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,sr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = ANDHI (* FLD (i_Rn1), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = SRLHI (* FLD (i_Rn1), 1);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* sra: sra $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,sra) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = ANDHI (* FLD (i_Rn1), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = SRAHI (* FLD (i_Rn1), 1);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* srb: srb $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,srb) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = ANDHI (SRLHI (* FLD (i_Rn1), 7), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = SRLHI (* FLD (i_Rn1), 8);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* slb: slb $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,slb) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = ANDHI (SRLHI (* FLD (i_Rn1), 8), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = SLLHI (* FLD (i_Rn1), 8);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* rrc: rrc $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,rrc) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  tmp_tmp = CPU (h_t);
  {
    BI opval = ANDHI (* FLD (i_Rn1), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = SRLHI (* FLD (i_Rn1), 1);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
  {
    HI opval = ORHI (* FLD (i_Rn1), SLLSI (tmp_tmp, 15));
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* rl: rl $Rn1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,rl) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = ANDHI (SRLHI (* FLD (i_Rn1), 15), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  {
    HI opval = ROLHI (* FLD (i_Rn1), 1);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* andgrgr: and $Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,andgrgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = ANDHI (* FLD (i_Rn), * FLD (i_Ri));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* orgrgr: or $Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,orgrgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = ORHI (* FLD (i_Rn), * FLD (i_Ri));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* xorgrgr: xor $Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,xorgrgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = XORHI (* FLD (i_Rn), * FLD (i_Ri));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* tstgrgr: tst $Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstgrgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = EQHI (ANDHI (* FLD (i_Rn), * FLD (i_Ri)), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* andgri8: and r0,$imm8 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,andgri8) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = ANDHI (GET_H_R0 (), FLD (f_imm8));
    SET_H_R0 (opval);
    TRACE_RESULT (current_cpu, abuf, "r0", 'x', opval);
  }
  {
    BI opval = EQHI (ANDHI (GET_H_R0 (), 255), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* orgri8: or r0,$imm8 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,orgri8) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = ORHI (GET_H_R0 (), FLD (f_imm8));
    SET_H_R0 (opval);
    TRACE_RESULT (current_cpu, abuf, "r0", 'x', opval);
  }
  {
    BI opval = EQHI (ANDHI (GET_H_R0 (), 255), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* xorgri8: xor r0,$imm8 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,xorgri8) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = XORHI (GET_H_R0 (), FLD (f_imm8));
    SET_H_R0 (opval);
    TRACE_RESULT (current_cpu, abuf, "r0", 'x', opval);
  }
  {
    BI opval = EQHI (ANDHI (GET_H_R0 (), 255), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* tstgri8: tst r0,$imm8 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstgri8) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = EQHI (ANDHI (GET_H_R0 (), FLD (f_imm8)), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* andgri16: and $Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,andgri16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  {
    HI opval = ANDHI (* FLD (i_Rn1), FLD (f_imm16));
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* orgri16: or $Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,orgri16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  {
    HI opval = ORHI (* FLD (i_Rn1), FLD (f_imm16));
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* xorgri16: xor $Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,xorgri16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  {
    HI opval = XORHI (* FLD (i_Rn1), FLD (f_imm16));
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* tstgri16: tst $Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,tstgri16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    BI opval = EQHI (ANDHI (* FLD (i_Rn1), FLD (f_imm16)), 0);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldwaRj: ldw $Rn,@[$Ai1+$Rj] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldwaRj) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldwaRj.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An2)), ZEXTHISI (* FLD (i_Rj)))));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldaaRj: ldw $An,@[$Ai1+$Rj] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldaaRj) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldaaRj.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_offset;
  tmp_offset = ADDSI (GET_H_AR (FLD (f_An2)), ZEXTHISI (* FLD (i_Rj)));
  {
    USI opval = ORHI (SLLHI (GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (tmp_offset)), 16), ANDHI (GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (tmp_offset, 2))), 65535));
    SET_H_AR (FLD (f_An), opval);
    TRACE_RESULT (current_cpu, abuf, "An", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* ldwaedisp5: ldw $Rn,@[$Ai1+$edisp5] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldwaedisp5) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldwaedisp5.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An2)), ZEXTSISI (FLD (f_edisp5)))));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldaaedisp5: ldw $An,@[$Ai1+$edisp5] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldaaedisp5) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldaaedisp5.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_offset;
  tmp_offset = ADDSI (GET_H_AR (FLD (f_An2)), ZEXTSISI (FLD (f_edisp5)));
  {
    USI opval = ORHI (SLLHI (GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (tmp_offset)), 16), ANDHI (GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (tmp_offset, 2))), 65535));
    SET_H_AR (FLD (f_An), opval);
    TRACE_RESULT (current_cpu, abuf, "An", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* ldwspedisp9: ldw $Rn,@[$sp+$edisp9] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldwspedisp9) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldwspedisp9.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_A15 (), FLD (f_edisp9))));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldw-gr-a-disp16: ldw $Rn,@[$Ai+$disp16] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldw_gr_a_disp16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_gr_a_disp16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    HI opval = GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An1)), FLD (f_disp16))));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldw-ar-a-disp16: ldw $An,@[$Ai+$disp16] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldw_ar_a_disp16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_ar_a_disp16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  SI tmp_offset;
  tmp_offset = ADDSI (GET_H_AR (FLD (f_An1)), FLD (f_disp16));
  {
    USI opval = ORHI (SLLHI (GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (tmp_offset)), 16), ANDHI (GETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (tmp_offset, 2))), 65535));
    SET_H_AR (FLD (f_An), opval);
    TRACE_RESULT (current_cpu, abuf, "An", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* ldbaRj: ldb $Dn,@[$Ai1+$Rj] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldbaRj) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldbaRj.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = GETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An2)), ZEXTHISI (* FLD (i_Rj)))));
    * FLD (i_Dn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Dn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldbadisp4: ldb $Dn,@[$Ai1+$disp4] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldbadisp4) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldbadisp4.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = GETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An2)), ZEXTSISI (FLD (f_disp4)))));
    * FLD (i_Dn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Dn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldba8disp8: ldb r0,@[a8+$disp8] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldba8disp8) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldba8disp8.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = GETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_A8 (), FLD (f_disp8))));
    SET_H_R0 (opval);
    TRACE_RESULT (current_cpu, abuf, "r0", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldbadisp16: ldb $Dn,@[$Ai+$disp16] */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldbadisp16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldbadisp16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    HI opval = GETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An1)), FLD (f_disp16))));
    * FLD (i_Dn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Dn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldEnDi: ld $En,$Di */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldEnDi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldEnDi.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = * FLD (i_Di);
    SET_H_ER (FLD (f_En), opval);
    TRACE_RESULT (current_cpu, abuf, "En", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldDnEi: ld $Dn,$Ei */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldDnEi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldDnEi.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = CPU (h_er[FLD (f_En)]);
    * FLD (i_Dn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Dn", 'x', opval);
  }
if (EQSI (FLD (f_Dn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Dn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 4);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Dn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Dn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* ldRnRi: ld $Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldRnRi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = * FLD (i_Ri);
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 4);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* ldAnAi: ld $An,$Ai */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldAnAi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_ar_a_disp16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    USI opval = GET_H_AR (FLD (f_An1));
    SET_H_AR (FLD (f_An), opval);
    TRACE_RESULT (current_cpu, abuf, "An", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldAnpc: ld $An1,pc */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldAnpc) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    USI opval = ADDSI (pc, 4);
    SET_H_AR (FLD (f_An1), opval);
    TRACE_RESULT (current_cpu, abuf, "An1", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldr0srx: ld r0,$Rs */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldr0srx) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldr0srx.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = * FLD (i_Rs);
    SET_H_R0 (opval);
    TRACE_RESULT (current_cpu, abuf, "r0", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldsrxr0: ld $Rs,r0 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldsrxr0) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldsrxr0.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    UHI opval = GET_H_R0 ();
    * FLD (i_Rs) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rs", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldsrr0: ld sr,r0 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldsrr0) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = GET_H_R0 ();
    SET_H_SR (opval);
    TRACE_RESULT (current_cpu, abuf, "sr", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldr0sr: ld r0,sr */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldr0sr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = GET_H_SR ();
    SET_H_R0 (opval);
    TRACE_RESULT (current_cpu, abuf, "r0", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* ldi8: ld $Rn,$imm8 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldi8) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldi8.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = FLD (f_imm8);
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }
if (EQSI (FLD (f_Rn), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z0) = opval;
    written |= (1 << 4);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn), 0);
    CPU (h_z1) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* ldi16: ld $Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldi16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  {
    HI opval = FLD (f_imm16);
    * FLD (i_Rn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn1", 'x', opval);
  }
if (EQSI (FLD (f_Rn1), 6)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z0) = opval;
    written |= (1 << 4);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_Rn1), 7)) {
  {
    BI opval = EQHI (* FLD (i_Rn1), 0);
    CPU (h_z1) = opval;
    written |= (1 << 5);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* lda22: ld $An,$eimm22 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,lda22) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    USI opval = FLD (f_imm22);
    SET_H_AR (FLD (f_An), opval);
    TRACE_RESULT (current_cpu, abuf, "An", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* popgr: pop $Rlist */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,popgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_popgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

calmrisc16bf_pop_gr (current_cpu, pc, FLD (f_Rlist));

  return vpc;
#undef FLD
}

/* popar: pop $Alist */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,popar) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_popgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

calmrisc16bf_pop_ar (current_cpu, pc, FLD (f_Rlist));

  return vpc;
#undef FLD
}

/* ldc: ldc $Rn,@$Ai */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ldc) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_gr_a_disp16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = GETMEMHI (current_cpu, pc, calmrisc16bf_program_address (GET_H_AR (FLD (f_An1))));
    * FLD (i_Rn) = opval;
    TRACE_RESULT (current_cpu, abuf, "Rn", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* stwaRj: ldw @[$An2+$Rj],$Ri1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,stwaRj) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stwaRj.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = * FLD (i_Ri1);
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An2)), ZEXTHISI (* FLD (i_Rj)))), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* staaRj: ldw @[$Ai1+$Rj],$An */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,staaRj) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldaaRj.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_offset;
  tmp_offset = ADDSI (GET_H_AR (FLD (f_An2)), ZEXTHISI (* FLD (i_Rj)));
  {
    HI opval = SRLSI (GET_H_AR (FLD (f_An)), 16);
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (tmp_offset), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
  {
    HI opval = GET_H_AR (FLD (f_An));
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (tmp_offset, 2)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* stwaedisp5: ldw @[$An2+$edisp5],$Ri1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,stwaedisp5) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stwaedisp5.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = * FLD (i_Ri1);
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An2)), ZEXTSISI (FLD (f_edisp5)))), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* staaedisp5: ldw @[$Ai1+$edisp5],$An */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,staaedisp5) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldaaedisp5.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_offset;
  tmp_offset = ADDSI (GET_H_AR (FLD (f_An2)), ZEXTSISI (FLD (f_edisp5)));
  {
    HI opval = SRLSI (GET_H_AR (FLD (f_An)), 16);
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (tmp_offset), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
  {
    HI opval = GET_H_AR (FLD (f_An));
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (tmp_offset, 2)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* stwspedisp9: ldw @[$sp+$edisp9],$Ri1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,stwspedisp9) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stwspedisp9.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = * FLD (i_Ri1);
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_A15 (), FLD (f_edisp9))), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* stwadisp16: ldw @[$An1+$disp16],$Ri1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,stwadisp16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stwadisp16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    HI opval = * FLD (i_Ri1);
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An1)), FLD (f_disp16))), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* stw-ar-a-disp16: ldw @[$Ai+$disp16],$An */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,stw_ar_a_disp16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_ar_a_disp16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  SI tmp_offset;
  tmp_offset = ADDSI (GET_H_AR (FLD (f_An1)), FLD (f_disp16));
  {
    HI opval = SRLSI (GET_H_AR (FLD (f_An)), 16);
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (tmp_offset), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
  {
    HI opval = GET_H_AR (FLD (f_An));
    SETMEMHI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (tmp_offset, 2)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* stbaRm: ldb @[$An2+$Rm],$Di */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,stbaRm) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stbaRm.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    QI opval = TRUNCHIQI (* FLD (i_Di));
    SETMEMQI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An2)), ZEXTHISI (* FLD (i_Rm)))), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* stbadisp4: ldb @[$An2+$disp4],$Di */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,stbadisp4) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stbadisp4.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    QI opval = TRUNCHIQI (* FLD (i_Di));
    SETMEMQI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An2)), ZEXTSISI (FLD (f_disp4)))), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* stba8disp8: ldb @[a8+$disp8],r0 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,stba8disp8) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldba8disp8.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    QI opval = TRUNCHIQI (GET_H_R0 ());
    SETMEMQI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_A8 (), FLD (f_disp8))), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* stbadisp16: ldb @[$An1+$disp16],$Di */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,stbadisp16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_stbadisp16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    QI opval = TRUNCHIQI (* FLD (i_Di));
    SETMEMQI (current_cpu, pc, calmrisc16bf_data_address (ADDSI (GET_H_AR (FLD (f_An1)), FLD (f_disp16))), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* pushgr: push $Rlist */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,pushgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_popgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

calmrisc16bf_push_gr (current_cpu, pc, FLD (f_Rlist));

  return vpc;
#undef FLD
}

/* pushar: push $Alist */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,pushar) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_popgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

calmrisc16bf_push_ar (current_cpu, pc, FLD (f_Rlist));

  return vpc;
#undef FLD
}

/* bitr: bitr @[a8+r1],$bs3 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,bitr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bitr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  UQI tmp_tmp;
  UQI tmp_mask;
  SI tmp_address;
  tmp_address = ADDSI (GET_H_A8 (), GET_H_R1 ());
  tmp_tmp = GETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (tmp_address));
  {
    BI opval = ANDQI (INVQI (SRLQI (tmp_tmp, FLD (f_bs3))), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  tmp_mask = INVSI (SLLSI (1, FLD (f_bs3)));
  {
    UQI opval = ANDQI (tmp_tmp, tmp_mask);
    SETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (tmp_address), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* bits: bits @[a8+r1],$bs3 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,bits) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bitr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  UQI tmp_tmp;
  UQI tmp_mask;
  SI tmp_address;
  tmp_address = ADDSI (GET_H_A8 (), GET_H_R1 ());
  tmp_tmp = GETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (tmp_address));
  {
    BI opval = ANDQI (INVQI (SRLQI (tmp_tmp, FLD (f_bs3))), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  tmp_mask = SLLSI (1, FLD (f_bs3));
  {
    UQI opval = ORQI (tmp_tmp, tmp_mask);
    SETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (tmp_address), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* bitc: bitc @[a8+r1],$bs3 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,bitc) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bitr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  UQI tmp_tmp;
  UQI tmp_mask;
  SI tmp_address;
  tmp_address = ADDSI (GET_H_A8 (), GET_H_R1 ());
  tmp_tmp = GETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (tmp_address));
  {
    BI opval = ANDQI (INVQI (SRLQI (tmp_tmp, FLD (f_bs3))), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
  tmp_mask = SLLSI (1, FLD (f_bs3));
  {
    UQI opval = XORQI (tmp_tmp, tmp_mask);
    SETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (tmp_address), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* bitt: bitt @[a8+r1],$bs3 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,bitt) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bitr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  UQI tmp_tmp;
  SI tmp_address;
  tmp_address = ADDSI (GET_H_A8 (), GET_H_R1 ());
  tmp_tmp = GETMEMUQI (current_cpu, pc, calmrisc16bf_data_address (tmp_address));
  {
    BI opval = ANDQI (INVQI (SRLQI (tmp_tmp, FLD (f_bs3))), 1);
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* cmpgegr: cmp ge,$Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpgegr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = GEHI (* FLD (i_Rn), * FLD (i_Ri));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpgtgr: cmp gt,$Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpgtgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = GTHI (* FLD (i_Rn), * FLD (i_Ri));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpugegr: cmp uge,$Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpugegr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = GEUHI (* FLD (i_Rn), * FLD (i_Ri));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpugtgr: cmp ugt,$Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpugtgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = GTUHI (* FLD (i_Rn), * FLD (i_Ri));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpeqgr: cmp eq,$Rn,$Ri */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpeqgr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgrgr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = EQHI (* FLD (i_Rn), * FLD (i_Ri));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpgegrimm6: cmp ge,$Dn,$imm6 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpgegrimm6) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpgegrimm6.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = GEHI (* FLD (i_Dn), FLD (f_imm6));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpeqgrimm8: cmp eq,$Dn,$imm8 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpeqgrimm8) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpeqgrimm8.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = EQHI (* FLD (i_Dn), FLD (f_imm8));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpgei16: cmp ge,$Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpgei16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    BI opval = GEHI (* FLD (i_Rn1), FLD (f_imm16));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpgti16: cmp gt,$Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpgti16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    BI opval = GTHI (* FLD (i_Rn1), FLD (f_imm16));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpugei16: cmp uge,$Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpugei16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    BI opval = GEUHI (* FLD (i_Rn1), FLD (f_imm16));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpugti16: cmp ugt,$Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpugti16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    BI opval = GTUHI (* FLD (i_Rn1), FLD (f_imm16));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpeqi16: cmp eq,$Rn1,$eimm16 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpeqi16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addgri16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    BI opval = EQHI (* FLD (i_Rn1), FLD (f_imm16));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpeqarar: cmp eq,$An,$Ai */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpeqarar) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldw_ar_a_disp16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    BI opval = EQSI (GET_H_AR (FLD (f_An)), GET_H_AR (FLD (f_An1)));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cmpeqa22: cmp eq,$An,$eimm22 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cmpeqa22) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    BI opval = EQSI (GET_H_AR (FLD (f_An)), FLD (f_imm22));
    CPU (h_t) = opval;
    TRACE_RESULT (current_cpu, abuf, "t", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* braext: bra $ec2,$elabel8 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,braext) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

((void) 0); /*nop*/

  return vpc;
#undef FLD
}

/* bradext: brad $ec2,$elabel8 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,bradext) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

((void) 0); /*nop*/

  return vpc;
#undef FLD
}

/* bra: bra $elabel11 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,bra) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    USI opval = FLD (i_elabel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* brad: brad $elabel11 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,brad) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    USI opval = FLD (i_elabel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* brt: brt $elabel11 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,brt) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

if (CPU (h_t)) {
  {
    USI opval = FLD (i_elabel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* brtd: brtd $elabel11 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,brtd) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
if (CPU (h_t)) {
  {
    USI opval = FLD (i_elabel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* brf: brf $elabel11 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,brf) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

if (NOTBI (CPU (h_t))) {
  {
    USI opval = FLD (i_elabel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* brfd: brfd $elabel11 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,brfd) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bra.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
if (NOTBI (CPU (h_t))) {
  {
    USI opval = FLD (i_elabel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* bnzd: bnzd $H,$elabel8 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,bnzd) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bnzd.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
{
if (EQSI (FLD (f_H), 6)) {
if (EQBI (CPU (h_z0), 0)) {
  {
    USI opval = FLD (i_elabel8);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}
} else {
if (EQBI (CPU (h_z1), 0)) {
  {
    USI opval = FLD (i_elabel8);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}
}
  {
    HI opval = SUBHI (* FLD (i_H), 1);
    * FLD (i_H) = opval;
    TRACE_RESULT (current_cpu, abuf, "H", 'x', opval);
  }
if (EQSI (FLD (f_H), 6)) {
  {
    BI opval = EQHI (* FLD (i_H), 0);
    CPU (h_z0) = opval;
    written |= (1 << 7);
    TRACE_RESULT (current_cpu, abuf, "z0", 'x', opval);
  }
} else {
if (EQSI (FLD (f_H), 7)) {
  {
    BI opval = EQHI (* FLD (i_H), 0);
    CPU (h_z1) = opval;
    written |= (1 << 8);
    TRACE_RESULT (current_cpu, abuf, "z1", 'x', opval);
  }
}
}
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jpfAi: jpf $Ai */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,jpfAi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

if (EQBI (CPU (h_t), 0)) {
  {
    USI opval = GET_H_AR (FLD (f_An1));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jpfimm22: jpf $imm22 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,jpfimm22) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

if (EQBI (CPU (h_t), 0)) {
  {
    USI opval = FLD (f_imm22);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jptAi: jpt $Ai */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,jptAi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

if (EQBI (CPU (h_t), 1)) {
  {
    USI opval = GET_H_AR (FLD (f_An1));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jptimm22: jpt $imm22 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,jptimm22) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

if (EQBI (CPU (h_t), 1)) {
  {
    USI opval = FLD (f_imm22);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jmpAi: jmp $Ai */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,jmpAi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    USI opval = GET_H_AR (FLD (f_An1));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jmpimm22: jmp $imm22 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,jmpimm22) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

  {
    USI opval = FLD (f_imm22);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jsrAi: jsr $Ai */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,jsrAi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addari16.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    USI opval = ADDSI (pc, 2);
    SET_H_A14 (opval);
    TRACE_RESULT (current_cpu, abuf, "a14", 'x', opval);
  }
  {
    USI opval = GET_H_AR (FLD (f_An1));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jsrimm22: jsr $imm22 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,jsrimm22) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lda22.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 4);

{
  {
    USI opval = ADDSI (pc, 4);
    SET_H_A14 (opval);
    TRACE_RESULT (current_cpu, abuf, "a14", 'x', opval);
  }
  {
    USI opval = FLD (f_imm22);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* bsrd: bsrd $elabel13 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,bsrd) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bsrd.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    USI opval = ADDSI (pc, 4);
    SET_H_A14 (opval);
    TRACE_RESULT (current_cpu, abuf, "a14", 'x', opval);
  }
{
  {
    USI opval = FLD (i_elabel13);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* retd: retd */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,retd) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    USI opval = GET_H_A14 ();
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* swi: swi $imm6 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,swi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cmpgegrimm6.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    SI opval = calmrisc16_swi (current_cpu, pc, FLD (f_imm6));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* retfiq: ret_fiq */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,retfiq) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = GET_H_SSR_FIQ ();
    SET_H_SR (opval);
    TRACE_RESULT (current_cpu, abuf, "sr", 'x', opval);
  }
  {
    USI opval = ORHI (SLLHI (GET_H_SPCH_FIQ (), 16), ANDHI (GET_H_SPCL_FIQ (), 65535));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* retirq: ret_irq */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,retirq) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = GET_H_SSR_IRQ ();
    SET_H_SR (opval);
    TRACE_RESULT (current_cpu, abuf, "sr", 'x', opval);
  }
  {
    USI opval = ORHI (SLLHI (GET_H_SPCH_IRQ (), 16), ANDHI (GET_H_SPCL_IRQ (), 65535));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* ret-swi: ret_swi */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,ret_swi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    HI opval = GET_H_SSR_SWI ();
    SET_H_SR (opval);
    TRACE_RESULT (current_cpu, abuf, "sr", 'x', opval);
  }
  {
    USI opval = GET_H_A14 ();
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* break: break */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,break) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

calmrisc16_break (current_cpu);

  return vpc;
#undef FLD
}

/* nop: nop */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,nop) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

((void) 0); /*nop*/

  return vpc;
#undef FLD
}

/* cldr: cld $Dn1,$imm5c */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cldr) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_cldr.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

  {
    HI opval = 0;
    * FLD (i_Dn1) = opval;
    TRACE_RESULT (current_cpu, abuf, "Dn1", 'x', opval);
  }

  return vpc;
#undef FLD
}

/* cldw: cld $imm5c,$Di1 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cldw) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

((void) 0); /*nop*/

  return vpc;
#undef FLD
}

/* cop: cop $imm13 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,cop) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

((void) 0); /*nop*/

  return vpc;
#undef FLD
}

/* sys: sys $imm5 */

static SEM_PC
SEM_FN_NAME (calmrisc16bf,sys) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

((void) 0); /*nop*/

  return vpc;
#undef FLD
}

/* Table of all semantic fns.  */

static const struct sem_fn_desc sem_fns[] = {
  { CALMRISC16BF_INSN_X_INVALID, SEM_FN_NAME (calmrisc16bf,x_invalid) },
  { CALMRISC16BF_INSN_X_AFTER, SEM_FN_NAME (calmrisc16bf,x_after) },
  { CALMRISC16BF_INSN_X_BEFORE, SEM_FN_NAME (calmrisc16bf,x_before) },
  { CALMRISC16BF_INSN_X_CTI_CHAIN, SEM_FN_NAME (calmrisc16bf,x_cti_chain) },
  { CALMRISC16BF_INSN_X_CHAIN, SEM_FN_NAME (calmrisc16bf,x_chain) },
  { CALMRISC16BF_INSN_X_BEGIN, SEM_FN_NAME (calmrisc16bf,x_begin) },
  { CALMRISC16BF_INSN_CLRSRFE, SEM_FN_NAME (calmrisc16bf,clrsrfe) },
  { CALMRISC16BF_INSN_SETSRFE, SEM_FN_NAME (calmrisc16bf,setsrfe) },
  { CALMRISC16BF_INSN_TSTSRFE, SEM_FN_NAME (calmrisc16bf,tstsrfe) },
  { CALMRISC16BF_INSN_CLRSRIE, SEM_FN_NAME (calmrisc16bf,clrsrie) },
  { CALMRISC16BF_INSN_SETSRIE, SEM_FN_NAME (calmrisc16bf,setsrie) },
  { CALMRISC16BF_INSN_TSTSRIE, SEM_FN_NAME (calmrisc16bf,tstsrie) },
  { CALMRISC16BF_INSN_CLRSRTE, SEM_FN_NAME (calmrisc16bf,clrsrte) },
  { CALMRISC16BF_INSN_SETSRTE, SEM_FN_NAME (calmrisc16bf,setsrte) },
  { CALMRISC16BF_INSN_TSTSRTE, SEM_FN_NAME (calmrisc16bf,tstsrte) },
  { CALMRISC16BF_INSN_CLRSRV, SEM_FN_NAME (calmrisc16bf,clrsrv) },
  { CALMRISC16BF_INSN_SETSRV, SEM_FN_NAME (calmrisc16bf,setsrv) },
  { CALMRISC16BF_INSN_TSTSRV, SEM_FN_NAME (calmrisc16bf,tstsrv) },
  { CALMRISC16BF_INSN_CLRSRZ0, SEM_FN_NAME (calmrisc16bf,clrsrz0) },
  { CALMRISC16BF_INSN_SETSRZ0, SEM_FN_NAME (calmrisc16bf,setsrz0) },
  { CALMRISC16BF_INSN_TSTSRZ0, SEM_FN_NAME (calmrisc16bf,tstsrz0) },
  { CALMRISC16BF_INSN_CLRSRZ1, SEM_FN_NAME (calmrisc16bf,clrsrz1) },
  { CALMRISC16BF_INSN_SETSRZ1, SEM_FN_NAME (calmrisc16bf,setsrz1) },
  { CALMRISC16BF_INSN_TSTSRZ1, SEM_FN_NAME (calmrisc16bf,tstsrz1) },
  { CALMRISC16BF_INSN_CLRSRPM, SEM_FN_NAME (calmrisc16bf,clrsrpm) },
  { CALMRISC16BF_INSN_SETSRPM, SEM_FN_NAME (calmrisc16bf,setsrpm) },
  { CALMRISC16BF_INSN_TSTSRPM, SEM_FN_NAME (calmrisc16bf,tstsrpm) },
  { CALMRISC16BF_INSN_ADDGRGR, SEM_FN_NAME (calmrisc16bf,addgrgr) },
  { CALMRISC16BF_INSN_SUBGRGR, SEM_FN_NAME (calmrisc16bf,subgrgr) },
  { CALMRISC16BF_INSN_ADDGRGRC, SEM_FN_NAME (calmrisc16bf,addgrgrc) },
  { CALMRISC16BF_INSN_SUBGRGRC, SEM_FN_NAME (calmrisc16bf,subgrgrc) },
  { CALMRISC16BF_INSN_MULUU, SEM_FN_NAME (calmrisc16bf,muluu) },
  { CALMRISC16BF_INSN_MULUS, SEM_FN_NAME (calmrisc16bf,mulus) },
  { CALMRISC16BF_INSN_MULSU, SEM_FN_NAME (calmrisc16bf,mulsu) },
  { CALMRISC16BF_INSN_MULSS, SEM_FN_NAME (calmrisc16bf,mulss) },
  { CALMRISC16BF_INSN_ADDGRI7, SEM_FN_NAME (calmrisc16bf,addgri7) },
  { CALMRISC16BF_INSN_SUBGRI7, SEM_FN_NAME (calmrisc16bf,subgri7) },
  { CALMRISC16BF_INSN_ADDGRI16, SEM_FN_NAME (calmrisc16bf,addgri16) },
  { CALMRISC16BF_INSN_ADDGRI16C, SEM_FN_NAME (calmrisc16bf,addgri16c) },
  { CALMRISC16BF_INSN_SUBGRI16C, SEM_FN_NAME (calmrisc16bf,subgri16c) },
  { CALMRISC16BF_INSN_ADDARGR, SEM_FN_NAME (calmrisc16bf,addargr) },
  { CALMRISC16BF_INSN_SUBARGR, SEM_FN_NAME (calmrisc16bf,subargr) },
  { CALMRISC16BF_INSN_ADDARI5, SEM_FN_NAME (calmrisc16bf,addari5) },
  { CALMRISC16BF_INSN_SUBARI5, SEM_FN_NAME (calmrisc16bf,subari5) },
  { CALMRISC16BF_INSN_ADDARI16, SEM_FN_NAME (calmrisc16bf,addari16) },
  { CALMRISC16BF_INSN_SUBARI16, SEM_FN_NAME (calmrisc16bf,subari16) },
  { CALMRISC16BF_INSN_COM, SEM_FN_NAME (calmrisc16bf,com) },
  { CALMRISC16BF_INSN_COM2, SEM_FN_NAME (calmrisc16bf,com2) },
  { CALMRISC16BF_INSN_COMC, SEM_FN_NAME (calmrisc16bf,comc) },
  { CALMRISC16BF_INSN_DECC, SEM_FN_NAME (calmrisc16bf,decc) },
  { CALMRISC16BF_INSN_INCC, SEM_FN_NAME (calmrisc16bf,incc) },
  { CALMRISC16BF_INSN_DT, SEM_FN_NAME (calmrisc16bf,dt) },
  { CALMRISC16BF_INSN_EXT, SEM_FN_NAME (calmrisc16bf,ext) },
  { CALMRISC16BF_INSN_RR, SEM_FN_NAME (calmrisc16bf,rr) },
  { CALMRISC16BF_INSN_SR, SEM_FN_NAME (calmrisc16bf,sr) },
  { CALMRISC16BF_INSN_SRA, SEM_FN_NAME (calmrisc16bf,sra) },
  { CALMRISC16BF_INSN_SRB, SEM_FN_NAME (calmrisc16bf,srb) },
  { CALMRISC16BF_INSN_SLB, SEM_FN_NAME (calmrisc16bf,slb) },
  { CALMRISC16BF_INSN_RRC, SEM_FN_NAME (calmrisc16bf,rrc) },
  { CALMRISC16BF_INSN_RL, SEM_FN_NAME (calmrisc16bf,rl) },
  { CALMRISC16BF_INSN_ANDGRGR, SEM_FN_NAME (calmrisc16bf,andgrgr) },
  { CALMRISC16BF_INSN_ORGRGR, SEM_FN_NAME (calmrisc16bf,orgrgr) },
  { CALMRISC16BF_INSN_XORGRGR, SEM_FN_NAME (calmrisc16bf,xorgrgr) },
  { CALMRISC16BF_INSN_TSTGRGR, SEM_FN_NAME (calmrisc16bf,tstgrgr) },
  { CALMRISC16BF_INSN_ANDGRI8, SEM_FN_NAME (calmrisc16bf,andgri8) },
  { CALMRISC16BF_INSN_ORGRI8, SEM_FN_NAME (calmrisc16bf,orgri8) },
  { CALMRISC16BF_INSN_XORGRI8, SEM_FN_NAME (calmrisc16bf,xorgri8) },
  { CALMRISC16BF_INSN_TSTGRI8, SEM_FN_NAME (calmrisc16bf,tstgri8) },
  { CALMRISC16BF_INSN_ANDGRI16, SEM_FN_NAME (calmrisc16bf,andgri16) },
  { CALMRISC16BF_INSN_ORGRI16, SEM_FN_NAME (calmrisc16bf,orgri16) },
  { CALMRISC16BF_INSN_XORGRI16, SEM_FN_NAME (calmrisc16bf,xorgri16) },
  { CALMRISC16BF_INSN_TSTGRI16, SEM_FN_NAME (calmrisc16bf,tstgri16) },
  { CALMRISC16BF_INSN_LDWARJ, SEM_FN_NAME (calmrisc16bf,ldwaRj) },
  { CALMRISC16BF_INSN_LDAARJ, SEM_FN_NAME (calmrisc16bf,ldaaRj) },
  { CALMRISC16BF_INSN_LDWAEDISP5, SEM_FN_NAME (calmrisc16bf,ldwaedisp5) },
  { CALMRISC16BF_INSN_LDAAEDISP5, SEM_FN_NAME (calmrisc16bf,ldaaedisp5) },
  { CALMRISC16BF_INSN_LDWSPEDISP9, SEM_FN_NAME (calmrisc16bf,ldwspedisp9) },
  { CALMRISC16BF_INSN_LDW_GR_A_DISP16, SEM_FN_NAME (calmrisc16bf,ldw_gr_a_disp16) },
  { CALMRISC16BF_INSN_LDW_AR_A_DISP16, SEM_FN_NAME (calmrisc16bf,ldw_ar_a_disp16) },
  { CALMRISC16BF_INSN_LDBARJ, SEM_FN_NAME (calmrisc16bf,ldbaRj) },
  { CALMRISC16BF_INSN_LDBADISP4, SEM_FN_NAME (calmrisc16bf,ldbadisp4) },
  { CALMRISC16BF_INSN_LDBA8DISP8, SEM_FN_NAME (calmrisc16bf,ldba8disp8) },
  { CALMRISC16BF_INSN_LDBADISP16, SEM_FN_NAME (calmrisc16bf,ldbadisp16) },
  { CALMRISC16BF_INSN_LDENDI, SEM_FN_NAME (calmrisc16bf,ldEnDi) },
  { CALMRISC16BF_INSN_LDDNEI, SEM_FN_NAME (calmrisc16bf,ldDnEi) },
  { CALMRISC16BF_INSN_LDRNRI, SEM_FN_NAME (calmrisc16bf,ldRnRi) },
  { CALMRISC16BF_INSN_LDANAI, SEM_FN_NAME (calmrisc16bf,ldAnAi) },
  { CALMRISC16BF_INSN_LDANPC, SEM_FN_NAME (calmrisc16bf,ldAnpc) },
  { CALMRISC16BF_INSN_LDR0SRX, SEM_FN_NAME (calmrisc16bf,ldr0srx) },
  { CALMRISC16BF_INSN_LDSRXR0, SEM_FN_NAME (calmrisc16bf,ldsrxr0) },
  { CALMRISC16BF_INSN_LDSRR0, SEM_FN_NAME (calmrisc16bf,ldsrr0) },
  { CALMRISC16BF_INSN_LDR0SR, SEM_FN_NAME (calmrisc16bf,ldr0sr) },
  { CALMRISC16BF_INSN_LDI8, SEM_FN_NAME (calmrisc16bf,ldi8) },
  { CALMRISC16BF_INSN_LDI16, SEM_FN_NAME (calmrisc16bf,ldi16) },
  { CALMRISC16BF_INSN_LDA22, SEM_FN_NAME (calmrisc16bf,lda22) },
  { CALMRISC16BF_INSN_POPGR, SEM_FN_NAME (calmrisc16bf,popgr) },
  { CALMRISC16BF_INSN_POPAR, SEM_FN_NAME (calmrisc16bf,popar) },
  { CALMRISC16BF_INSN_LDC, SEM_FN_NAME (calmrisc16bf,ldc) },
  { CALMRISC16BF_INSN_STWARJ, SEM_FN_NAME (calmrisc16bf,stwaRj) },
  { CALMRISC16BF_INSN_STAARJ, SEM_FN_NAME (calmrisc16bf,staaRj) },
  { CALMRISC16BF_INSN_STWAEDISP5, SEM_FN_NAME (calmrisc16bf,stwaedisp5) },
  { CALMRISC16BF_INSN_STAAEDISP5, SEM_FN_NAME (calmrisc16bf,staaedisp5) },
  { CALMRISC16BF_INSN_STWSPEDISP9, SEM_FN_NAME (calmrisc16bf,stwspedisp9) },
  { CALMRISC16BF_INSN_STWADISP16, SEM_FN_NAME (calmrisc16bf,stwadisp16) },
  { CALMRISC16BF_INSN_STW_AR_A_DISP16, SEM_FN_NAME (calmrisc16bf,stw_ar_a_disp16) },
  { CALMRISC16BF_INSN_STBARM, SEM_FN_NAME (calmrisc16bf,stbaRm) },
  { CALMRISC16BF_INSN_STBADISP4, SEM_FN_NAME (calmrisc16bf,stbadisp4) },
  { CALMRISC16BF_INSN_STBA8DISP8, SEM_FN_NAME (calmrisc16bf,stba8disp8) },
  { CALMRISC16BF_INSN_STBADISP16, SEM_FN_NAME (calmrisc16bf,stbadisp16) },
  { CALMRISC16BF_INSN_PUSHGR, SEM_FN_NAME (calmrisc16bf,pushgr) },
  { CALMRISC16BF_INSN_PUSHAR, SEM_FN_NAME (calmrisc16bf,pushar) },
  { CALMRISC16BF_INSN_BITR, SEM_FN_NAME (calmrisc16bf,bitr) },
  { CALMRISC16BF_INSN_BITS, SEM_FN_NAME (calmrisc16bf,bits) },
  { CALMRISC16BF_INSN_BITC, SEM_FN_NAME (calmrisc16bf,bitc) },
  { CALMRISC16BF_INSN_BITT, SEM_FN_NAME (calmrisc16bf,bitt) },
  { CALMRISC16BF_INSN_CMPGEGR, SEM_FN_NAME (calmrisc16bf,cmpgegr) },
  { CALMRISC16BF_INSN_CMPGTGR, SEM_FN_NAME (calmrisc16bf,cmpgtgr) },
  { CALMRISC16BF_INSN_CMPUGEGR, SEM_FN_NAME (calmrisc16bf,cmpugegr) },
  { CALMRISC16BF_INSN_CMPUGTGR, SEM_FN_NAME (calmrisc16bf,cmpugtgr) },
  { CALMRISC16BF_INSN_CMPEQGR, SEM_FN_NAME (calmrisc16bf,cmpeqgr) },
  { CALMRISC16BF_INSN_CMPGEGRIMM6, SEM_FN_NAME (calmrisc16bf,cmpgegrimm6) },
  { CALMRISC16BF_INSN_CMPEQGRIMM8, SEM_FN_NAME (calmrisc16bf,cmpeqgrimm8) },
  { CALMRISC16BF_INSN_CMPGEI16, SEM_FN_NAME (calmrisc16bf,cmpgei16) },
  { CALMRISC16BF_INSN_CMPGTI16, SEM_FN_NAME (calmrisc16bf,cmpgti16) },
  { CALMRISC16BF_INSN_CMPUGEI16, SEM_FN_NAME (calmrisc16bf,cmpugei16) },
  { CALMRISC16BF_INSN_CMPUGTI16, SEM_FN_NAME (calmrisc16bf,cmpugti16) },
  { CALMRISC16BF_INSN_CMPEQI16, SEM_FN_NAME (calmrisc16bf,cmpeqi16) },
  { CALMRISC16BF_INSN_CMPEQARAR, SEM_FN_NAME (calmrisc16bf,cmpeqarar) },
  { CALMRISC16BF_INSN_CMPEQA22, SEM_FN_NAME (calmrisc16bf,cmpeqa22) },
  { CALMRISC16BF_INSN_BRAEXT, SEM_FN_NAME (calmrisc16bf,braext) },
  { CALMRISC16BF_INSN_BRADEXT, SEM_FN_NAME (calmrisc16bf,bradext) },
  { CALMRISC16BF_INSN_BRA, SEM_FN_NAME (calmrisc16bf,bra) },
  { CALMRISC16BF_INSN_BRAD, SEM_FN_NAME (calmrisc16bf,brad) },
  { CALMRISC16BF_INSN_BRT, SEM_FN_NAME (calmrisc16bf,brt) },
  { CALMRISC16BF_INSN_BRTD, SEM_FN_NAME (calmrisc16bf,brtd) },
  { CALMRISC16BF_INSN_BRF, SEM_FN_NAME (calmrisc16bf,brf) },
  { CALMRISC16BF_INSN_BRFD, SEM_FN_NAME (calmrisc16bf,brfd) },
  { CALMRISC16BF_INSN_BNZD, SEM_FN_NAME (calmrisc16bf,bnzd) },
  { CALMRISC16BF_INSN_JPFAI, SEM_FN_NAME (calmrisc16bf,jpfAi) },
  { CALMRISC16BF_INSN_JPFIMM22, SEM_FN_NAME (calmrisc16bf,jpfimm22) },
  { CALMRISC16BF_INSN_JPTAI, SEM_FN_NAME (calmrisc16bf,jptAi) },
  { CALMRISC16BF_INSN_JPTIMM22, SEM_FN_NAME (calmrisc16bf,jptimm22) },
  { CALMRISC16BF_INSN_JMPAI, SEM_FN_NAME (calmrisc16bf,jmpAi) },
  { CALMRISC16BF_INSN_JMPIMM22, SEM_FN_NAME (calmrisc16bf,jmpimm22) },
  { CALMRISC16BF_INSN_JSRAI, SEM_FN_NAME (calmrisc16bf,jsrAi) },
  { CALMRISC16BF_INSN_JSRIMM22, SEM_FN_NAME (calmrisc16bf,jsrimm22) },
  { CALMRISC16BF_INSN_BSRD, SEM_FN_NAME (calmrisc16bf,bsrd) },
  { CALMRISC16BF_INSN_RETD, SEM_FN_NAME (calmrisc16bf,retd) },
  { CALMRISC16BF_INSN_SWI, SEM_FN_NAME (calmrisc16bf,swi) },
  { CALMRISC16BF_INSN_RETFIQ, SEM_FN_NAME (calmrisc16bf,retfiq) },
  { CALMRISC16BF_INSN_RETIRQ, SEM_FN_NAME (calmrisc16bf,retirq) },
  { CALMRISC16BF_INSN_RET_SWI, SEM_FN_NAME (calmrisc16bf,ret_swi) },
  { CALMRISC16BF_INSN_BREAK, SEM_FN_NAME (calmrisc16bf,break) },
  { CALMRISC16BF_INSN_NOP, SEM_FN_NAME (calmrisc16bf,nop) },
  { CALMRISC16BF_INSN_CLDR, SEM_FN_NAME (calmrisc16bf,cldr) },
  { CALMRISC16BF_INSN_CLDW, SEM_FN_NAME (calmrisc16bf,cldw) },
  { CALMRISC16BF_INSN_COP, SEM_FN_NAME (calmrisc16bf,cop) },
  { CALMRISC16BF_INSN_SYS, SEM_FN_NAME (calmrisc16bf,sys) },
  { 0, 0 }
};

/* Add the semantic fns to IDESC_TABLE.  */

void
SEM_FN_NAME (calmrisc16bf,init_idesc_table) (SIM_CPU *current_cpu)
{
  IDESC *idesc_table = CPU_IDESC (current_cpu);
  const struct sem_fn_desc *sf;
  int mach_num = MACH_NUM (CPU_MACH (current_cpu));

  for (sf = &sem_fns[0]; sf->fn != 0; ++sf)
    {
      const CGEN_INSN *insn = idesc_table[sf->index].idata;
      int valid_p = (CGEN_INSN_VIRTUAL_P (insn)
		     || CGEN_INSN_MACH_HAS_P (insn, mach_num));
#if FAST_P
      if (valid_p)
	idesc_table[sf->index].sem_fast = sf->fn;
      else
	idesc_table[sf->index].sem_fast = SEM_FN_NAME (calmrisc16bf,x_invalid);
#else
      if (valid_p)
	idesc_table[sf->index].sem_full = sf->fn;
      else
	idesc_table[sf->index].sem_full = SEM_FN_NAME (calmrisc16bf,x_invalid);
#endif
    }
}

